function HTML2MetaHTML(s)
{
  var res = s.replace(/&auml;/g, unescape("%E4"));
  res = res.replace(/&ouml;/g, unescape("%F6"));
  res = res.replace(/&uuml;/g, unescape("%FC"));
  res = res.replace(/&Auml;/g, unescape("%C4"));
  res = res.replace(/&Ouml;/g, unescape("%D6"));
  res = res.replace(/&Uuml;/g, unescape("%DC"));
  res = res.replace(/&szlig;/g, unescape("%DF"));
  return res;
}

var msTable = "<table cellpadding=0 cellspacing=0 textpadding=0 #h#>";

var t1 = msTable + '<tr><td align=center valign=middle nowrap style="white-space:nowrap;">';
var t2 = '</td><td align=center valign=middle nowrap style="white-space:nowrap;"> &nbsp;';
var t3 = '&nbsp; </td><td align=center valign=middle nowrap style="white-space:nowrap;">';
var t4 = '</td></tr></table>';

var sym = (top.document.all || top.document.layers) && !window.opera;

var mCode = new Array(
//  new Array(" ", 0, ' '),
  new Array("=>", 0, sym ? ' <font face="symbol">&#222;</font> ' : ' &rArr; '),
  new Array("<=>", 0, sym ? ' <font face="symbol">&#219;</font> ' : ' &hArr; '),
  new Array(";", 0, ';&nbsp;'),
  new Array("\\in", 0, sym ? '<font face="symbol">&#206;</font>' : '&isin;'),
  new Array("\\notin", 0, sym ? '<font face="symbol">&#207;</font>' : '&notin'),
  new Array("\\subset", 2, sym ? ' <font face="symbol">&#204;</font> ' : ' &sub; '),
  new Array("\\subseteq", 1, sym ? ' <font face="symbol">&#205;</font> ' : ' &sube; '),
  new Array("\\supset", 2, sym ? ' <font face="symbol">&#201;</font> ' : ' &sup; '),
  new Array("\\supseteq", 1, sym ? ' <font face="symbol">&#202;</font> ' : ' &supe; '),
  new Array("\\notsubset", 2, sym ? ' <font face="symbol">&#203;</font> ' : ' &nsub; '),
  new Array("\\all", 2, sym ? ' <font face="symbol">&#34;</font>' : ' &forall;'),
  new Array("\\exist", 2, sym ? ' <font face="symbol">&#36;</font>' : ' &exist'),
  new Array("<=", 3, sym ? ' <font face="symbol">&#163;</font> ' : ' &le; '),
  new Array(">=", 3, sym ? ' <font face="symbol">&#179;</font> ' : ' &ge; '),
  new Array("\\asymp", 4, sym ? ' <font face="symbol">&#187;</font> ' : ' &asymp; '),
  new Array("\\to", 4, sym ? ' <font face="symbol">&#174;</font> ' : ' &harr; '),
  new Array("=", 4, ' = '),
  new Array("\\ne", 4, sym ? ' <font face="symbol">&#185;</font> ' : ' &ne; '),
  new Array("<", 4, ' &lt; '),
  new Array(">", 4, ' &gt; '),
  new Array("| ", 4, '| '),
  new Array("|", 4, '|'),
  new Array("\\over", 4, msTable+'<tr><td id="mft" align=center valign=middle nowrap style="white-space:nowrap;">', '</td></tr><tr><td height="2px" style="font-size:2px;" id="mfl">&nbsp;</td></tr><tr><td align=center valign=middle nowrap style="white-space:nowrap;">', "</td></tr></table>"),
  new Array("\\cup", 5, sym ? '<font face="symbol">&#200;</font>' : '&cup;'),
  new Array("\\cap", 6, sym ? '<font face="symbol">&#199;</font>' : '&cap;'),
  new Array("+", 7, '+'),
  new Array("-", 7, top.document.layers ? '-' : '&minus;'),
  new Array("\\pm", 7, sym ? '<font face="symbol">&#177;</font>' : '&plusmn;'),
//  new Array("-", 7, '-'),
  new Array("*", 8, sym ? '<font face="symbol">&#215;</font>' : '&sdot;'),
  new Array(": ", 8, ': '),
  new Array(":", 8, ':'),
  new Array("/", 8, msTable+'<tr><td id="mft" align=center valign=middle nowrap style="white-space:nowrap;">', '</td></tr><tr><td height="2px" bgcolor="#000000" style="font-size:2px;" id="mfl">&nbsp;</td></tr><tr><td align=center valign=middle nowrap style="white-space:nowrap;">', "</td></tr></table>"),
//  new Array(" ", 8, ''), //msTable+"<tr><td align=center valign=middle nowrap style="white-space:nowrap;">", "</td><td align=center valign=middle nowrap>", "</td></tr></table>", '&nbsp;'),
  new Array("_", 9, msTable+'<tr><td align=right valign=top style="white-space:nowrap;">', '</td><td align=left valign=bottom style="white-space:nowrap;"><sub>', "</sub></td></tr></table>"),
  new Array("^", 9, msTable+'<tr><td align=right valign=bottom style="white-space:nowrap;">', '</td><td align=left valign=top style="white-space:nowrap;"><sup>', "</sup></td></tr></table>"),
  new Array("\\root", 10, "", msTable+'<tr><td align=right valign=bottom style="white-space:nowrap;">&radic;</td><td align=left valign=top style="white-space:nowrap;border-top:1px solid #000000;padding-top:0px;padding-bottom:1px;">', "</td></tr></table>"),
  new Array("\\nroot", 10, msTable+'<tr><td align=right valign=bottom style="white-space:nowrap;"><sup><u>', '</u></sup>&radic;</td><td align=left valign=top style="white-space:nowrap;border-top:1px solid #000000;padding-top:0px;padding-bottom:1px;">', "</td></tr></table>"),
  new Array("\\per", 10, "", msTable+'<td align=left valign=top style="white-space:nowrap;border-top:1px solid #000000;padding-top:0px;padding-bottom:1px;">', "</td></tr></table>"),
  new Array("\\u", 10, "", msTable+'<td align=left valign=top style="white-space:nowrap;border-bottom:1px solid #000000;">', "</td></tr></table>"),
  new Array("\\du", 10, "", msTable+'<td align=left valign=top style="white-space:nowrap;border-bottom:3px double  #000000;">', "</td></tr></table>")
);

mChar = new Array(
  /\\null/g, "&#198;", "&Oslash;",
  /\\sigmaf/g, "V", "&sigmaf;",
  /\\thetasym/g, "J", "&thetasym;",
  /\\ypsih/g, "&#161;", "&upsih;",
  /\\asterisk/g, "*", "*",

  /\\Alpha/g, "A", "&Alpha;",
  /\\Beta/g, "B", "&Beta;",
  /\\Gamma/g, "G", "&Gamma;",
  /\\Delta/g, "D", "&Delta;",
  /\\Epsilon/g, "E", "&Epsilon;",
  /\\Zeta/g, "Z", "&Zeta;",
  /\\Eta/g, "H", "&Eta;",
  /\\Theta/g, "Q", "&Theta;",
  /\\Iota/g, "I", "&Iota;",
  /\\Kappa/g, "K", "&Kappa;",
  /\\Lambda/g, "L", "&Lambda;",
  /\\Mu/g, "M", "&Mu;",
  /\\Nu/g, "N", "&Nu;",
  /\\Xi/g, "X", "&Xi;",
  /\\Omicron/g, "O", "&Omicron;",
  /\\Pi/g, "P", "&Pi;",
  /\\Rho/g, "R", "&Rho;",
  /\\Sigma/g, "S", "&Sigma;",
  /\\Tau/g, "T", "&Tau;",
  /\\Upsilon/g, "U", "&Upsilon;",
  /\\Phi/g, "F", "&Phi;",
  /\\Chi/g, "C", "&Chi;",
  /\\Psi/g, "Y", "&Psi;",
  /\\Omega/g, "W", "&Omega;",

  /\\alpha/g, "a", "&alpha;",
  /\\beta/g, "b", "&beta;",
  /\\gamma/g, "g", "&gamma;",
  /\\delta/g, "d", "&delta;",
  /\\epsilon/g, "e", "&epsilon;",
  /\\zeta/g, "z", "&zeta;",
  /\\eta/g, "h", "&eta;",
  /\\theta/g, "q", "&theta;",
  /\\iota/g, "i", "&iota;",
  /\\kappa/g, "k", "&kappa;",
  /\\lambda/g, "l", "&lambda;",
  /\\mu/g, "m", "&mu;",
  /\\nu/g, "n", "&nu;",
  /\\xi/g, "x", "&xi;",
  /\\omicron/g, "o", "&omicron;",
  /\\pi/g, "p", "&pi;",
  /\\rho/g, "r", "&rho;",
  /\\sigma/g, "s", "&sigma;",
  /\\tau/g, "t", "&tau;",
  /\\ypsilon/g, "u", "&upsilon;",
  /\\phi/g, "j", "&phi;",
  /\\chi/g, "c", "&chi;",
  /\\psi/g, "y", "&psi;",
  /\\omega/g, "w", "&omega;"
);

mUniCode = new Array(
  /\\C/g, "&#x2102;",
  /\\N/g, "&#x2115;",
  /\\P/g, "&#x2119;",
  /\\Q/g, "&#x211A;",
  /\\R/g, "&#x211D;",
  /\\Z/g, "&#x2124;",
  /\\L/g, "&#x2124;");


function Text2m(sVal)
{
  sVal = sVal.replace(/@.*$/,"");
  var s1 = "<B>"+Text2mh(HTML2MetaHTML(sVal).replace(/\\upsilon/g, "\\ypsilon").replace(/\\upsih/g, "\\ypsih").replace(/\\infin/g, "\\irfin").replace(/&lt;/g, '<').replace(/&gt;/g, '>'), 16)+"</B>";   //14
  var i = s1.search(/<table([^>]*)style="/i);
  if ( i != -1 )
    s1 = s1.substr(0, i+13+RegExp.$1.length)+'display:inline'+((document.all && !window.opera) ? '' : '-block')+';vertical-align:middle;'+s1.substr(i+13+RegExp.$1.length);
  for (var i = 0; i < mChar.length; i += 3)
    s1 = s1.replace(mChar[i], sym ? '<font face="symbol">'+mChar[i+1]+'</font>' : mChar[i+2]);
  for (var i = 0; i < mUniCode.length; i += 2)
    s1 = s1.replace(mUniCode[i], '<span style="font-family:Lucida Sans Unicode, Arial Unicode MS, Hiragino Kaku Gothic Pro; font-weight:normal;">'+mUniCode[i+1]+'</span>');
  s1 = s1.replace(/\\irfin/g, "&infin;");
  return s1;
}

function SetH(s, h)
{
  return s.replace(/#h#/g, 'style="font-size:'+h+'px;font-weight:bold;"');
}

function IsClean(s)
{
  if ( s.search(/table/) != -1 )
    return false;
  return true;
}

function IsCleanSubSup(s)
{
/*  if ( s.search(/sup/) != -1 ) // sieht besser aus
    return false;
  if ( s.search(/sub/) != -1 )
    return false;*/
  return IsClean(s);
}

function NoTable(s)
{
  if ( s.search(/table/) != -1 )
    return false;
  return true;
}

function SafeJoin(s1, s2, h)
{
  var res = "";
  if ( (IsClean(s1) && IsClean(s2)) || s1 == "" || s2 == "" )
    res = s1+s2;
  else
    res = SetH(msTable, h) + '<tr><td style="white-space:nowrap;">' + s1 + '</td><td style="white-space:nowrap;">' + s2 + "</td></tr></table>";
  return res;
}

function SafeJoin3(s1, s2, s3, h)
{
  var res = "";
  if ( IsClean(s1) && IsClean(s2) && IsClean(s3) )
    res = s1+s2+s3;
  else
    res = SetH(msTable, h) + '<tr><td style="white-space:nowrap;">' +
            s1 + '</td><td style="white-space:nowrap;">' +
            s2 + '</td><td style="white-space:nowrap;">' +
            s3 + "</td></tr></table>";
  return res;
}

function GetIndExp(s, i1, i2)
{
  var i = i1;
  if ( i2 == 99999 )
    i2 = s.length;
  if ( i1 >= i2 )
    return i;
  var nBracket = 0;
  var nEBracket = 0;
  var nCollect = 0;
  var nVCollect = 0;
  do
  {
    var ch = s.charAt(i);
    if ( ch == '(' )
      nBracket++;
    else if ( ch == ')' )
    {
      if ( nBracket > 0 )
        nBracket--;
    }
    else if ( ch == '[' )
      nEBracket++;
    else if ( ch == ']' )
    {
      if ( nEBracket > 0 )
        nEBracket--;
    }
    else if ( ch == '\\' && i > 0 && s.charAt(i+1) == "{" )
    {
      nVCollect++;
      i++;
    }
    else if ( ch == '\\' && i > 0 && s.charAt(i-1) == "}" )
    {
      if ( nVCollect > 0 )
        nVCollect--;
      i++;
    }
    else if ( ch == '{' )
      nCollect++;
    else if ( ch == '}' )
    {
      if ( nCollect > 0 )
        nCollect--;
    }
    i++;
  }
  while ( i < i2 && (nBracket != 0 || nEBracket != 0 || nCollect != 0 || nVCollect != 0 ) );
  return i;
}

function Text2mh(sVal, h)
{
  var sOut = "";
  var s = sVal;
  while ( s.length > 0 && s.charAt(0) == ' ' )
    s = s.substring(1);
  while ( s.length > 0 && s.charAt(s.length-1) == ' ' )
    s = s.substring(0, s.length-1);
  if ( s == '' )
    return sOut;
  var i = s.length-1;
  var iSp = i;
  var typeSp = -1;
  var prioritySp = 100;
  var nBracket = 0;
  var nEBracket = 0;
  var nCollect = 0;
  var nVCollect = 0;
  var aBracket = 99999;
  var eBracket = 99999;
  var aEBracket = 99999;
  var eEBracket = 99999;
  var aCollect = 99999;
  var eCollect = 99999;
  var aVCollect = 99999;
  var eVCollect = 99999;
  var iExp = 99999;
  var iInd = 99999;
  // Splitpunkt Sp finden (Achtung: rckwrts)
  while ( i >= 0 )
  {
    var ch = s.charAt(i);
    if ( ch == ')' )
    {
      nBracket++;
      if ( eBracket == 99999 )
        eBracket = i;
    }
    else if ( ch == '(' )
    {
      if ( nBracket > 0 )
        nBracket--;
      if ( aBracket == 99999 && nBracket == 0)
        aBracket = i;
    }
    else if ( ch == ']' )
    {
      nEBracket++;
      if ( eEBracket == 99999 )
        eEBracket = i;
    }
    else if ( ch == '[' )
    {
      if ( nEBracket > 0 )
        nEBracket--;
      if ( aEBracket == 99999 && nEBracket == 0)
        aEBracket = i;
    }
    else if ( ch == '}' && i > 0 && s.charAt(i-1) == "\\" )
    {
      nVCollect++;
      if ( eVCollect == 99999 )
        eVCollect = i;
    }
    else if ( ch == '{' && i > 0 && s.charAt(i-1) == "\\" )
    {
      if ( nVCollect > 0 )
        nVCollect--;
      if ( aVCollect == 99999 && nVCollect == 0)
        aVCollect = i;
    }
    else if ( ch == '}' )
    {
      nCollect++;
      if ( eCollect == 99999 )
        eCollect = i;
    }
    else if ( ch == '{' )
    {
      if ( nCollect > 0 )
        nCollect--;
      if ( aCollect == 99999 && nCollect == 0)
        aCollect = i;
    }
    else if ( nBracket == 0 && nCollect == 0 && nEBracket == 0 && nVCollect == 0 )
    {
      for (var j = 0; j < mCode.length; j++)
        if ( s.substring(i, i+mCode[j][0].length) == mCode[j][0] )
        {
          if ( mCode[j][1] < prioritySp )
          {
            prioritySp = mCode[j][1];
            iSp = i;
            typeSp = j;
          }
        }
      //  <=> vs. => Problem
      if ( typeSp == 0 && iSp > 0 && s.charAt(iSp-1) == '<' )
      {
        iSp--;
        typeSp++;
      }
      if ( ch == '^' && iExp == 99999 )
        iExp = i;
      if ( ch == '_' && iInd == 99999 )
        iInd = i;
    }
    i--;
  }

  if ( prioritySp != 100 && prioritySp != 9 )
  {
    var sPre = Text2mh(s.substring(0, iSp), h);
    var sPost = Text2mh(s.substring(iSp+mCode[typeSp][0].length), h);
    if ( mCode[typeSp].length == 3 )
    {
      if ( NoTable(sPre) && NoTable(sPost) )
        sOut = '<SPAN style="white-space:nowrap">' + sPre + '' + mCode[typeSp][2] + '' + sPost + '</SPAN>';
      else if ( sPre == "" )
        sOut = SetH(t1, h) + mCode[typeSp][2] + t3 + sPost + t4;
      else
        sOut = SetH(t1, h) + sPre + t2 + mCode[typeSp][2] + t3 + sPost + t4;
    }
    else if ( prioritySp == 10 && mCode[typeSp][2] == "" )
    {
      sOut = SafeJoin(sPre, SetH(mCode[typeSp][3], h) + sPost +
             SetH(mCode[typeSp][4], h), h);
    }
    else if ( mCode[typeSp][0] == '/' )
      sOut = SetH(mCode[typeSp][2], h) + sPre.replace(/id="mf."/g, "") +
             SetH(mCode[typeSp][3], h) + sPost.replace(/id="mf."/g, "") +
             SetH(mCode[typeSp][4], h);
    else
      sOut = SetH(mCode[typeSp][2], h) + sPre +
             SetH(mCode[typeSp][3], h) + sPost +
             SetH(mCode[typeSp][4], h);
  }
  else if ( prioritySp == 9 )
  {
    // Teile ermitteln
    var ifirst = (iExp < iInd) ? iExp : iInd;
    var s1 = Text2mh(s.substring(0, ifirst), h);
    var sInd = '';
    var sExp = '';
    var s1Ind = '';
    var s1Exp = '';
    if ( iInd != 99999 )
    {
      iIndE = GetIndExp(s, iInd+1, iExp < iInd ? 99999 : iExp);
      if ( iIndE == iExp || iIndE == s.length )
        sInd = s.substring(iInd+1, iIndE);
      else
      {
        return SafeJoin(Text2mh(s.substring(0, iIndE), h), Text2mh(s.substring(iIndE), h), h);
      }
      s1Ind = Text2mh(sInd, h-2)
    }
    if ( iExp != 99999 )
    {
      iExpE = GetIndExp(s, iExp+1, iInd < iExp ? 99999 : iInd);
      if ( iExpE == iInd || iExpE == s.length )
        sExp = s.substring(iExp+1, iExpE);
      else
      {
        return SafeJoin(Text2mh(s.substring(0, iExpE), h), Text2mh(s.substring(iExpE), h), h);
      }
      s1Exp = Text2mh(sExp, h-2)
    }
    // schreiben
    if ( sInd == '' && IsCleanSubSup(s1Exp) && IsCleanSubSup(s1) )
      sOut = s1 + '<sup>' + Text2mh(sExp, h) + '</sup>';
    else  if ( sExp == '' && IsCleanSubSup(s1Ind) && IsCleanSubSup(s1) )
      sOut = s1 + '<sub>' + Text2mh(sInd, h) + '</sub>';
    else
      sOut = SetH(msTable, h) +
        ( sExp == '' ? '' : '<tr style="font-size:'+(h-2)+'px;"><td>&nbsp;</td><td valign=bottom align=left style="white-space:nowrap;">' + s1Exp + '</td></tr>') +
        '<tr style="font-size:'+h+'px;"><td valign=middle align=right style="white-space:nowrap;">' + s1 + '</td><td>&nbsp;</td><tr>' +
        ( sInd == '' ? '' : '<tr style="font-size:'+(h-2)+'px;"><td>&nbsp;</td><td valign=top align=left style="white-space:nowrap;">' + s1Ind + '</td></tr>') +
        '</table>';
  }
  else
  {
    var MaxeBracket = -1;
    if ( aBracket != 99999 && eBracket != 9999 && eBracket > MaxeBracket )
      MaxeBracket = eBracket;
    if ( aCollect != 99999 && eCollect != 9999 && eCollect > MaxeBracket )
      MaxeBracket = eCollect;
    if ( aEBracket != 99999 && eEBracket != 9999 && eEBracket > MaxeBracket )
      MaxeBracket = eEBracket;
    if ( aVCollect != 99999 && eVCollect != 9999 && eVCollect > MaxeBracket )
      MaxeBracket = eVCollect;
    if ( eBracket < MaxeBracket )
      eBracket = 99999;
    if ( eCollect < MaxeBracket )
      eCollect = 99999;
    if ( eEBracket < MaxeBracket )
      eEBracket = 99999;
    if ( eVCollect < MaxeBracket )
      eVCollect = 99999;
    if ( aBracket != 99999 && eBracket != 99999 )
      sOut = DoBracket(s, h, aBracket, eBracket, 0, "(", ")");
    else if ( aEBracket != 99999 && eEBracket != 99999 )
      sOut = DoBracket(s, h, aEBracket, eEBracket, 0, "[", "]");
    else if ( aVCollect != 99999 && eVCollect != 99999 )
      sOut = DoBracket(s, h, aVCollect, eVCollect, 1, "{", "}");
    else if ( aCollect != 99999 && eCollect != 99999 )
    {
      var sPre = '' + Text2mh(s.substring(0, aCollect), h);
      if ( eCollect < aCollect ) { return SafeJoin3(sPre, "{", Text2mh(s.substring(aCollect+1), h), h); }
      var sMid = Text2mh(s.substring(aCollect+1, eCollect), h);
      var sPost = '' + Text2mh(s.substring(eCollect+1), h);
      if ( (sPre == '' && sPost == '') || (IsClean(sPre) && IsClean(sMid) && IsClean(sPost)) )
        sOut = sPre + sMid + sPost;
      else
        sOut = SetH(msTable, h) + "<tr><td>" +
               ((sPre == "") ? "" : sPre + "</td><td>") +
               sMid +
               ((sPost == "") ? "" : "</td><td>" + sPost) +
               "</td></tr></table>";
    }
    else
    {
      //sOut = '<span style="font-size:'+h+'pt;">'+s+'</span>';
      //sOut = s;
      sOut = '<span style="font-size:'+h+'px;font-weight:bold;">'+s+'</span>';
    }
  }
  return sOut;
}

function DoBracket(s, h, a, e, addChar, sOpen, sClose)
{
  var sPre = '' + Text2mh(s.substring(0, a-addChar), h);
  if ( e < a ) { return SafeJoin3(sPre, sOpen, Text2mh(s.substring(a+1), h), h); }
  var sMid = Text2mh(s.substring(a+1, e-addChar), h);
  var sPost = '' + Text2mh(s.substring(e+1), h);
  if ( IsClean(sPre) && IsClean(sMid) && IsClean(sPost) )
    return sPre+'<SPAN style="white-space:nowrap">'+sOpen+sMid+sClose+"</SPAN>"+sPost;
  else
  {
    var sB1 = "", sB2 = "";
    if ( sMid.indexOf('id="mft"') != -1 )
    {
      sB1 = '<span style="font-size:'+(2*h)+'px;font-weight:200;">';
      sB2 = "</span>";
    }
    return SetH(msTable, h) + '<tr><td style="white-space:nowrap">' +
           ((sPre == "") ? "" : sPre + "</td><td>") +
           sB1+sOpen+sB2+
           '</td><td style="white-space:nowrap;">' + sMid + "</td><td>"+
           sB1+sClose+sB2+
           ((sPost == "") ? "" : '</td><td style="white-space:nowrap">' + sPost) +
           "</td></tr></table>";
  }
}
