// study2000, Aug. 2005, TU Dresden, R. Kraue, Version 0.72 Code
// http://linus.psych.tu-dresden.de/Stupla/study2000

// Modi

var M_TEXT = 100;
var M_MATERIAL = 101;
var M_INTEGRATOR = 102;
var M_PROTOCOL = 103;
var M_PLAN = 104;
var M_END = 105;
var M_TOCMEDIA = 106;

var M_MEDIAOPEN = 200;

var Mode = (M_OVERVIEW != -1 && Media[M_OVERVIEW][0]) ? M_OVERVIEW + M_MEDIAOPEN : M_TEXT;
var OldMode = M_TEXT;
var InBaseCat = false;

var MAX_DEEP = 10;

// global data
var curNr = 0;
var lay;
var ie;
var dom;
var op;
var bas;
var tableButtons;
var LastChosenTopic = 0;

// Inhaltsverzeichnis
var ContWidth = "25%";
var LastDeep = new Array(MAX_DEEP);
var IsOpen = new Array(nTopic);
var MatHeight = 60+20*InTOCMediaTitle.length+(UsePlan ? 20 : 0)+(Media.length != 0 ? 20 : 0)+(top.control.SaveType && SaveType == 2 ? 20 : 0);
var OnContSwitching = 0;
var AllSwitch = 1;
var KeepCurClosed1 = -1;
var KeepCurClosed2 = -1;

// Notizen
var Notes = new Array(100);
var nNotes = 0;
var NoteAt = 0;
var NoteNr = 0;

// Markieren
var curMarkColor = 0;
var MarkFirst;
var MarkColor = new Array (
  "#00FF00", "#FFFF00", "#FF0000", "#00FFFF",
  "#FF00FF", "#C0C0C0", "#808000", "#0000FF",
  "#FF8000", "#FF8080", "#408080", "#80FF00",
  "#800000", "#8080FF", "#E24F1D", "#FFF9E3",
  "#FFFFFF");
var Marks = new Array(100);
var nMarks = 0;

// Folien
var FolieMatch = 0;
var FolieMode = new Array("(1:1)", "(Breite)", "(Hhe)", "(total)");

// Aufgabe
var mailanswerdo = false;
var mailansweraddress = "";

// allgemeine Merker
var Exploding = 0;
var LoadingData = 0;
var OnLoading = 1;
var OnLoading2 = 1;
var MedTopic = 0;
var MedI = 0;

// momentane Medienliste (wg. transdown)
var MedListMode = -1;
var MedListTopic = -1;
var MedListPos = -1;
var MedList;

// Plane
var Flight = 0;
var PlaneMode = 0;

var PM_MARK1 = 1;
var PM_MARK2 = 2;
var PM_NOTE = 3;

// Protocol
var Protocol = new Array();
var nProtocol = 0;
var LastTime;
var LastAction = "";

var TopicDuration = new Array(nTopic);
var TopicLast = new Array(nTopic);
var LastTopicRead = 0;

// Sheets
var PlayNr = 0;
var PlayButtonMode = 0;

var curSheets = -1;

// Glossarlinkkommentar
var GlossaryLinkStatus = "Klicken Sie hier um den Begriff im Glossar aufzurufen.";
// Media-Texte
var ModeTitle = new Array('Text', 'Material', 'Sammelmappe', 'Protokoll', 'Lernplan', 'Ende');

// Buttonstyle: contens, Media on, Media exist, Media not exist, speziell, Lernplan
var ButtonBgColor = new Array('#F5F5DC', '#1E90FF', '#1E90FF', '#808080', '#20B2AA', '#A07CD0');
var ButtonFontColor = new Array('#003366', '#DDFDF3', '#DDFDF3', '#A9A9A9', '#FFFFFF', '#DDFDF3');

// frequently used strings

var ISO = '<meta http-equiv="Content-Type" content="text/html; charset='+Charset+'">';

var DISPLAY_HEADER = '<body text="#333333" bgcolor="#FFFFFF" link="#000055" vlink="#550000" style="font-family:Arial;">\r\n';
var DIALOG_HEADER = '<body text="#003366" bgcolor="#F5F5DC" link="#000055" vlink="#550000">\r\n';

var NO_LINKDEKO = '<head>\r\n<style type="text/css">\r\n' +
    '  a:link { text-decoration:none }\r\n' +
    '  a:visited { text-decoration:none }\r\n' +
    '  a:active { text-decoration:none }\r\n' +
    '</style>'+ISO+'</head>\r\n';

// intern links and overview
var BackAction = "";

function GetMedia(mode, nr)
{
  var m = mode % M_MEDIAOPEN;
  if ( m >= M_TOCMEDIA )
    return InTOCMedia[m-M_TOCMEDIA];
  else
    return Media[m][nr];
}

function GetMediaTitle(mode)
{
  var m = mode % M_MEDIAOPEN;
  if ( m >= M_TOCMEDIA )
    return InTOCMediaTitle[m-M_TOCMEDIA];
  else
    return MediaTitle[m];
}

function GetMediaTitleShort(type)
{
  if ( type < M_TEXT )
    return MediaTitleShort[type];
  else if ( type < M_TOCMEDIA )
    return ModeTitle[type - M_TEXT];
  else
    return InTOCMediaTitleShort[type-M_TOCMEDIA];
}

function GetMediaStyle(mode)
{
  var m = mode % M_MEDIAOPEN;
  if ( m >= M_TOCMEDIA )
    return InTOCMediaStyle[m-M_TOCMEDIA];
  else
    return (m < M_TEXT) ? MediaStyle[m] : 0;
}

function IsMediaMode(m)
{
  return m < M_TEXT || M_TOCMEDIA <= m;
}

// display functions ------------------------------------------------

function SheetPlop(mode, nr, i)
{
  var s;
  if ( Available(nr) )
    s = '<A href="javascript:AddSheet(' + mode + ',' + nr + ',' + i + ')" target="control" '+MouseTip("Zu Sammelmappe hinzufgen.")+'>' +
          '<img src="' + base + '../Data/sheet.gif" alt="Zu Sammelmappe hinzufgen." border=0></A>\r\n';
  else
    s = '<img src="' + base + '../Data/sheetoff.gif" alt="Zu Sammelmappe hinzufgen. Medium gesperrt." border=0>\r\n';
  return s;
}

function SecondBookEntry(title, mode, comment)
{
  var Entry = '<span class="toc">'+title+'</span>';
  var action = (''+mode).length < 8 ? ('top.control.ChangeMode(' + mode + ')') : mode;
  if ( Mode == mode || Mode == mode + M_MEDIAOPEN )
    Entry = '<span class="tocOpen">'+title+'</span>';
  var s = '<tr><td valign="top"><IMG src="'+base+'../Data/dot3.gif" width="17" height="13" '+(ie||lay?'alt':'title')+'="Globale Funktion">\r\n</td>' +
      '<td colspan="10" valign="bottom"><A href="javascript:' + action + '" ' +
      ' title="' + comment + '" onMouseOver="status=\'' + title + '\'; return true;" ' +
      'onMouseOut="status=\'\'; return true;" target="control">' + Entry + '</A></td></tr>\r\n';
  return s;
}

function TitleText()
{
  if ( M_TEXT < Mode && Mode < M_MEDIAOPEN || M_TOCMEDIA + M_MEDIAOPEN <= Mode)
  {
    if ( Mode % M_MEDIAOPEN >= M_TOCMEDIA )
      return InTOCMediaTitle[Mode % M_MEDIAOPEN - M_TOCMEDIA];
    else
      return ModeTitle[Mode - M_TEXT];
  }
  else
    if ( curNr == -1 )
      return "Studierplatz 2000";
    else
      return Name[curNr];
}

function MediaLink(mode, nr, i)
{
  var s;
  var mData = GetMedia(mode, nr); //( mode >= M_TOCMEDIA ) ? InTOCMedia[mode-M_TOCMEDIA] : Media[mode][nr];
  if ( !Available(nr) )
    s = '  <span class="mediaUnAv" ';
  else if ( mData[i][0] != "" )
    s = '  <a href="javascript:top.control.StartMedia(' + mode + ', ' + nr + ', ' + i + ')"'+ (lay ? " " : ' target="control" ');
  else
    s = '  <span class="media" ';
  s += MouseTip(mData[i][2]) + '>' +
       mData[i][1];
  if ( mData[i][0] != "" && Available(nr) )
    s += '</a>\r\n';
  else
    s += '</span>\r\n';
  return s;
}

function MediaButton(text, value, width)
{
  var style = 2;
  if ( Mode % M_MEDIAOPEN == value || MediaCatBase[Mode % M_MEDIAOPEN] == value )
    style = 1;
  var Exist = (value == M_TEXT || TopicAndCapsHasMedia(value, curNr)) && !ExclTopic(curNr);
  var v1 = value+1;
  while ( !Exist && v1 < MediaTitle.length && MediaCatBase[v1] != -1 )
    Exist = TopicAndCapsHasMedia(v1++, curNr)
  if ( !Exist )
    style = 3;
  return Button(text, 'ChangeMode(' + value + ')', width, style,
    'Zeigt zum Thema zugeordnete' +  ((value == M_TEXT) ? 'n ' : ' ') + text +' an');
}

function MediaCheckButton(text, value)
{
  var s = '<input type="checkbox"';
  for (var i = 0; i < nMat; i++)
    if ( Mat[i] == value )
      s += " checked ";
  s += ' value="' + text + '" onClick="MatAdd(' + value + ')">' + text + ' ';
  return tableButtons ? '<td>'+s+'</td>' : s;
}

function ReqSwitchContMode()
{
  if ( OnContSwitching == 0 )
  {
    OnContSwitching = 1;
    setTimeout("SwitchContMode()", 30);
  }
}

function ShowButtons()
{
  ButtonCount = 0; // fr <Button>-Breite
  // Inhaltsbutton
  var sContens =
     GraphicButton("prev", "Prev()", posHistory > 0 ? 0 : 3, "Zurck") +
     GraphicButton("next", "Next()", posHistory < nHistory-1 ? 0 : 3, "Vorwrts") +
     ButtonSep +
     GraphicButton("cont", "ReqSwitchContMode()", 0, "Inhaltsverzeichnis verschieben bzw. ausblenden");
  if ( ContMode == 2 )
    sContens += GraphicButton("pageprev", "PagePrev()", curNr > 0 ? 0 : 3, "Eine Seite zurckblttern") +
                GraphicButton("pagenext", "PageNext()", (curNr < nTopic-1 && Available(curNr+1)) ? 0 : 3, "Eine Seite weiterblttern");
  var sControl;
  if ( Mode % M_MEDIAOPEN <= M_TEXT )
  {
    sControl = MediaButton("Text", M_TEXT, 60);
    for (var i = 0; i < MediaTitle.length; i++)
      if ( MediaCatBase[i] == -1 && i != M_QUEST )
        sControl += MediaButton(MediaTitle[i], i, 60);
  }
  else
  {
    sControl =
      Button("Zurck zum Lehrstoff", BackAction != "" ? BackAction : "BackToStuff(" + OldMode + ")", 50, 2, "Zurck zum Lehrstoff");
    BackAction = "";
  }
  sControl += ButtonSep;
  if ( Mode == M_MATERIAL )
  {
    sControl += (ie || dom ? '' : '<td>');
    for (var i = 0; i < MediaTitle.length; i++)
      if ( MediaCatBase[i] == -1 && i != M_QUEST )
        sControl += MediaCheckButton(MediaTitle[i], i);
    sControl += (ie || dom ? "" :  '</td>');
  }
  else if ( Mode == M_TEXT && !bas )
    sControl += (IsHtml(File[curNr]) ? "" : GraphicButton('mark', "TextMark()", 4, "Markieren") +
      GraphicButton('donote', "TextNote()", 4, "Notiz anhngen")) +
      GraphicButton('sheet',  "AddSheet(" + M_TEXT + ", top.control.curNr, 0)", 4, "Zu Sammelmappe hinzufgen.");
  else if ( Mode == M_VIDEO )
    ;
  else if ( Mode == M_EXPERIMENT )
    ;
  else if ( Mode == M_PUBLIKATION )
    ;
  else if ( Mode == M_LINK )
    ;
  else if ( (Mode % M_MEDIAOPEN) == M_FOLIE )
  {
    if ( TopicAndCapsHasGraphicMedia(M_FOLIE, curNr) )
      sControl += Button("Einpassen " + FolieMode[FolieMatch], "FolieSwitch()", 90, 4, "Folien auf Fenstergre anpassen");
  }
  else if ( Mode == M_PROTOCOL )
    ;
  else if ( Mode == M_INTEGRATOR )
    sControl +=
      Button("Mappe auswhlen", "SelectSheet()", 100, 4, "Sammelmappe auswhlen (falls mehrere vorhanden sind)") +
      Button("Neue Mappe", "NewSheet()", 70, 4, "Neue Sammelmappe anlegen") +
      Button("Mappe umbenennen", "RenameSheet()", 110, 4, "Die aktuell angezeigte Sammelmappe umbenennen") +
      Button("Mappe lschen", "KillSheet()", 100, 4, "Die aktuell angezeigte Sammelmappe lschen") + ButtonSep +
      Button("Play", "PlaySheet(0)", 50, 4, "Die aktuell angezeigte Sammelmappe als Dia-Show abspielen");
  else if ( Mode == M_PLAN )
    sControl +=
      Button("Plan auswhlen", "SelectPlan()", 100, 5, "Lernplan auswhlen (falls mehrere vorhanden sind)") +
      Button("Neuer Plan", "NewPlan()", 70, 5, "Neuen Lernplan anlegen") +
      Button("Plan umbenennen", "RenamePlan()", 110, 5, "Den aktuell angezeigten Lernplan umbenennen") +
      Button("Plan lschen", "KillPlan()", 100, 5, "Den aktuell angezeigten Lernplan lschen");
  if ( Mode >= M_MEDIAOPEN && !ExclTopic(curNr) )
  {
    CheckUpdateMedListPos(Mode, MedTopic, MedI);
    sControl += ButtonSep;
    if ( MedListPos > 0 )
      sControl += Button(lay ? "&lt;" : "<", 'MoveMedia(-1)', 30, 4, "Ein(e) "+MediaTitleShort[Mode-M_MEDIAOPEN]+" zurckblttern");
    if ( MedListPos +1 < MedList.length )
      sControl += Button(lay ? "&gt;" : ">", 'MoveMedia(1)', 30, 4, "Ein(e) "+MediaTitleShort[Mode-M_MEDIAOPEN]+" weiterblttern");
  }
  if ( BackAction != "" )
  {
    sControl += ButtonSep + Button("Zurck", BackAction, 70, 0, "Zurck zu Text/bersicht");
    BackAction = "";
  }
  if ( UsePlan )
  {
    if ( Mode >= M_MEDIAOPEN )
      CheckUpdatePlanPos(Mode, MedTopic, MedI);
    else
      CheckUpdatePlanPos(Mode, curNr, 0);
    if ( PlanPos >= 0 )
    {
      sControl += ButtonSep + GraphicButton('removeplan', "RemovePlan("+PlanNr+", "+PlanPos+")", 5, "Aus Lernplan entfernen.");
      var sTooltipAdd =  " [Lernplan \'"+Plan[PlanNr][1].split("\x01")[0]+"\' ("+(PlanPos+1)+"/"+(Plan[PlanNr].length-2)+")]";
      if ( PlanPos > 0 )
        sControl += Button(lay ? "&lt;" : "<", 'MovePlan(-1)', 30, 5, "Einen Eintrag im Lernplan zurckblttern"+sTooltipAdd);
      if ( PlanPos+3 < Plan[PlanNr].length )
        sControl += Button(lay ? "&gt;" : ">", 'MovePlan(1)', 30, 5, "Einen Eintrag im Lernplan weiterblttern"+sTooltipAdd);
      if ( tableButtons )
        sControl += "<td>&nbsp;" + CurPlanCheckbox()+"</td>";
      else
        sControl += "&nbsp; "+CurPlanCheckbox();
    }
    else
      if ( Mode == M_TEXT || Mode >= M_MEDIAOPEN )
        sControl += ButtonSep + GraphicButton('addplan', "AddPlan("+(Mode%M_MEDIAOPEN)+", "+(Mode >= M_MEDIAOPEN ? MedTopic : curNr)+", "+MedI+")", 5, "Zu Lernplan hinzufgen.");
      else if ( Mode < M_TEXT )
        sControl += ButtonSep + GraphicButton('addplan', "", 3, "Zu Lernplan hinzufgen (nur fr Texte und Medien).");
  }
  // Tab-simulierte/untersttzte Buttons abschlieen
  var sBut;
  if ( ContMode >= 1 )
  {
    if ( tableButtons )
    {
      sControl = '<table border=0 cellpadding=0 cellspacing=0><tr>' + sControl + '</tr></table>';
      sContens = '<table border=0 cellpadding=0 cellspacing=0><tr>' + sContens + '</tr></table>';
    }
    sBut = '<table border="0" cellpadding="0" cellspacing="0" width="100%"><tr><td>' +
      sControl +
      '</td><td align=right>' +
      sContens +
      '</td></tr></table>';
  }
  else if ( tableButtons )
    sBut = '<table border=0 cellpadding=0 cellspacing=0><tr><td>&nbsp;</td>' + sContens + '<td> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; </td>' + sControl + '</tr></table>';
  else
    sBut = sContens + '&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ' + sControl;
  if ( ie )
  {
    document.all.Buttons.innerHTML = sBut+' ';  // Leerzeichen wichtig fr IE Mac
    var but = document.all.tags("button");
    for (var i = 0; i < but.length; i++)
      if ( but[i].id )
        but[i].style.width = eval("document.all.a"+but[i].id+".offsetWidth")+12;
  }
  else if ( dom ) // DOM
    document.getElementById("Buttons").innerHTML = sBut;
  else // LAY, OP and BASE
  {
    var doc2 = lay ? document.Buttons.document : top.buttons.document;
    if ( lay )
      sBut = '<form>' + sBut + '</form>';
    else
      sBut = HEADER+'<body class="buttons">'+sBut+'</body>';
    doc2.close();
    doc2.clear();
    doc2.open();
    doc2.write(sBut);
    doc2.close();
  }
}

function CatLink(i)
{
  var s = '<p><a href="javascript:top.control.ChangeMode('+ i + ')" class="catLink">'+GetMediaTitle(i)+'</a></p>';
  return s;
}

function ShowDisplay()
{
  // alles da?
  if ( !top.data.display )
  {
    setTimeout("ShowDisplay()", 500);
    return;
  }
  // close small windows
  if ( DiaWin && !DiaWin.closed )
    DiaWin.close();
  if ( Flight )
    CrashDown();
  PlaneMode = 0;
  NoteAt = 0;
  NoteNr = 0;
  AddProt("");
  UpdateProt();
  if ( M_TEXT <= Mode && Mode < M_TOCMEDIA )
    InitProt(Mode, curNr, 0);
  if ( Mode == M_TEXT || OnLoading2 == 1 )
  {
    if ( curNr == -1 )
      window.open(base + '../Data/s2.htm', "display");
    else
    {
      if ( OnLoading2 == 1 && M_OVERVIEW != -1 && Media[M_OVERVIEW][0] )
        window.open(base + Media[0][0][0][0], "display");
      else if ( IsHtml(File[curNr]) )
        window.open(base + File[curNr], "display");
      else
        window.open(base + File[curNr] + ".htm", "display");
      OnLoading2 = 0;
    }
  }
  else if ( Mode == M_MATERIAL )
    setTimeout("ShowMaterial()", 30);
  else if ( Mode == M_PROTOCOL )
    setTimeout(M_AUFGABE == -1 ? "ShowProtocolList()" : "ShowProtocol()", 30);
  else if ( Mode == M_INTEGRATOR )
    setTimeout("ShowSheet()", 30);
  else if ( Mode == M_PLAN )
    setTimeout("ShowPlan()", 30);
  else
  {
    UpdateProt();
    var ShowCatList = false;
    // checken, ob mehr als eine Unterkategorie vorhanden
    if ( MediaCatBase[Mode] == -1 && !InBaseCat )
    {
      var iMode = TopicAndCapsHasMedia(Mode, curNr) ? Mode : -1;
      for (var i = Mode+1; i < MediaTitle.length; i++)
        if ( MediaCatBase[i] == -1 )
          break;
        else
          if ( TopicAndCapsHasMedia(i, curNr) )
            if ( iMode == -1 )
              iMode = i;
            else
            {
              iMode = -1;
              ShowCatList = true;
              break;
            }
      if ( iMode != -1 )
        Mode = iMode;
    }

    if ( ShowCatList )
    {
      var doc = top.data.display.document;
      doc.close();
      doc.clear();
      doc.open();
      doc.writeln(DISPLAY_HEADER_BODY, '<span class="catList">');
      for (var i = Mode; i < MediaTitle.length; i++)
        if ( MediaCatBase[i] == -1 && i != Mode )
          break;
        else
          if ( TopicAndCapsHasMedia(i, curNr) )
            doc.writeln(CatLink(i));
      doc.writeln('</span></body>');
      doc.close();
      return;
    }

    var mName = GetMediaTitle(Mode);
    var mStyle = GetMediaStyle(Mode);
    if ( MedListMode != Mode || MedListTopic != curNr )
      MakeMedList(Mode, curNr);

    if ( M_TOCMEDIA <= Mode && Mode < M_MEDIAOPEN && MedList.length == 1 )
    {
      StartMedia(Mode, MedList[0][0], MedList[0][1]);
      return;
    }

    AddHistory(Mode, curNr, 0, "");

    var iBase = (MediaCatBase[Mode] == -1) ? Mode : MediaCatBase[Mode];
    var sPreSubCatList = "", sPostSubCatList = "";
    for (var i = iBase; i < MediaTitle.length; i++)
      if ( i != Mode )
        if ( MediaCatBase[i] == -1 && i != iBase )
          break;
        else
          if ( TopicAndCapsHasMedia(i, curNr) )
            if ( i < Mode )
              sPreSubCatList += CatLink(i);
            else
              sPostSubCatList += CatLink(i);

    var doc;
    if ( (mStyle & 2) && M_TOCMEDIA <= Mode && Mode < M_MEDIAOPEN )
      doc = self.window.open("../Data/dummy.htm", mName.replace(/ /g, "_")).document;
    else {
      while ( !top.data.display.document ) ;
      doc = top.data.display.document;
    }
    doc.close();
    doc.clear();
    doc.open();
    doc.writeln(DISPLAY_HEADER_BODY,
      sPreSubCatList, '<span class="mediaHeader">',
      mName,
      '</span>',
      '<table border="0" cellpadding="4">\r\n');
    for (var i=0; i < MedList.length; i++ )
    {
      if ( i > 0 && MedList[i-1][0] != MedList[i][0] )
        doc.writeln('<tr><td>&nbsp;</td></tr>');
      var mData = GetMedia(Mode, MedList[i][0])[MedList[i][1]];
      var addText = "";
      var Haken = ""
      if ( Mode == M_AUFGABE )
      {
        addText = GetAddText("" + Mode + "." + MedList[i][0] + "." + MedList[i][1], "-1");
        if ( addText == "" )
          addText = mData[4] != 0 ? "; Bearbeitung abgebrochen" : "";
        else if ( addText == "-1" )
        {
          addText = "; Lsung wurde anzeigt";
          Haken = "f";
        }
        else
        {
          Haken = 1*addText >= 98 ? "h" : "f";
          addText = "; Ergebnis: " + addText + "%";
        }
      }
      doc.writeln('<tr><td valign="top">', MedList[i][0] == curNr ? "" : (lay || ie ? '<font face="Symbol">&#221;</font>' : '&uArr;'),
      HistoryPlop(mData[4], mData[5], -1, addText, Haken+SLP_L(Mode, MedList[i][0], MedList[i][1])), '</td><td valign="top">\r\n',
        SheetPlop(Mode, MedList[i][0], MedList[i][1]),
        '</td><td valign="top">\r\n',
        MediaLink(Mode, MedList[i][0], MedList[i][1]),
        '</td><td valign="top">\r\n',
        mData[2],
        '\r\n</td></tr>');
    }
    if ( MedList.length == 0 )
      doc.writeln('<tr><td>Keine Medien zugewiesen</td></tr>');
    doc.writeln('</table>',
      sPostSubCatList,
      '</body>');
    doc.close();
  }
}

function SaveShowDisplay()
{
  // alles da?
  if ( !top.data.display )
  {
    setTimeout("SaveShowDisplay()", 500);
    return;
  }
  ShowDisplay();
}

// control functions -----------------------------------------------

function ChangeMode(mode)
{
  CheckStoreExercise();
  InBaseCat = (mode == Mode) && (Mode % M_MEDIAOPEN <= M_TEXT) && MediaCatBase[Mode % M_MEDIAOPEN] == -1 && !InBaseCat;
  if ( Mode % M_MEDIAOPEN <= M_TEXT && !ExclTopic(curNr) )
    OldMode = Mode % M_MEDIAOPEN;
  if ( CheckFBs() )
    return;
  var DoSaveShow = ((Mode >= M_MEDIAOPEN) && (mode != M_TEXT)) ? 1 : 0;
  if ( (GetMediaStyle(Mode) & 2) || (GetMediaStyle(mode) & 2) )
    DoSaveShow = 0;
  if ( Mode > M_TEXT || mode > M_TEXT )
  {
    Mode = mode;
    if ( mode < M_TOCMEDIA || !(GetMediaStyle(mode) & 2) )
      setTimeout("ShowTitle()", 10);
    setTimeout("ShowMat()", 30);
  }
  else
    Mode = mode;
  if ( DoSaveShow == 1 )
  {
    window.open(base + '../Data/dummy.htm', "display");
    setTimeout("SaveShowDisplay()", 500);
  }
  else
    setTimeout("ShowDisplay()", 10);
  if ( mode < M_TOCMEDIA || mode >= M_MEDIAOPEN || !(GetMediaStyle(mode) & 2) )
    setTimeout("ShowButtons()", 10);
}

function SetTopicText(nr)  // returns from material
{
  var lct = LastChosenTopic;
  var DoSaveShow = (Mode >= M_MEDIAOPEN);
  Mode %= M_MEDIAOPEN;
  LastChosenTopic = nr;
  if ( CheckFBs() )
    return;
  if ( Mode > M_TEXT )
  {
    Mode = OldMode;
    setTimeout("ShowMat()", 30);
  }
  if ( ExclTopic(lct) && !ExclTopic(nr) )
    Mode = OldMode;
  if ( !ExclTopic(lct) && ExclTopic(nr) )
    OldMode = Mode;
  if ( Mode < M_TEXT && !TopicAndCapsHasMedia(Mode, nr) )  // rem this for to goto text in every case
    if ( MediaCatBase[Mode] != -1 && TopicAndCapsHasMedia(MediaCatBase[Mode], nr) )
      Mode = MediaCatBase[Mode]
    else
      Mode = M_TEXT;
  MedListMode = -1;
  if ( self.SpecialTopic && SpecialTopic[nr] )
  {
    if ( (SpecialTopic[nr][0] & 4) && SpecialTopic[nr][1] == "100.0" ) // Gate
      UnBlock(nr);
    if ( SpecialTopic[nr][0] & 3 )
    {
      SpecialTopic[nr][0] &= 14;
      var a = (""+SpecialTopic[nr][1]).split(/\./);
      if ( a[0] == 100 )
      {
        Mode = M_TEXT;
        setTimeout("ShowDisplay()", 60);
        setTimeout("ShowButtons()", 70);
        setTimeout("ShowTitle()", 80);
      }
      else
      {
        StartMedia(a[0], nr, a[1]);
        if ( SpecialTopic[nr][0] & 4 )
          UnBlock(nr);
      }
      setTimeout("ShowCont()", 50);
      return;
    }
  }
  setTimeout("ShowCont()", 50);
  if ( DoSaveShow == 1 )
  {
    window.open(base + '../Data/dummy.htm', "display");
    setTimeout("SaveShowDisplay()", 500);
  }
  else
    setTimeout("ShowDisplay()", 60);
  setTimeout("ShowButtons()", 70);
  setTimeout("ShowTitle()", 80);
//  ShowDisplay();  // org pos
  //setTimeout("ShowCont()", 40);
}

function UpDateCont(nr)
{
  curNr = nr;
  setTimeout("ShowCont()", 10);
}

function SwitchOpen(nr)
{
  if ( nr == KeepCurClosed2 )
    ShowCont();
  else if ( LastDeep[Deep[nr]] == nr ) // zuklappen eines automatisch geffnenet Kapitels
  {
    KeepCurClosed1 = nr;
    SetTopic(nr);
  }
  else
  {
    IsOpen[nr] = 1 - IsOpen[nr];
    ShowCont();
  }
  AllSwitch = 1;
}

function SwitchAllOpen()
{
  for (var i = 0; i < nTopic; i++)
    IsOpen[i] = AllSwitch;
  AllSwitch = 1-AllSwitch;
  ShowCont();
}

var MedI;

function FolieSwitch()
{
  FolieMatch = (FolieMatch+1) % 4;
  if ( Mode == M_FOLIE + M_MEDIAOPEN )
    StartMedia(M_FOLIE, curNr, MedI);
  else
    ShowButtons();
}

function GetExt(s, l)
{
  var ext = s;
  var i = ext.indexOf('"');
  if ( i != -1 )
    ext = ext.substring(0, i);
  return ext.substring(ext.length-l).toUpperCase();
}

function IsGraphic(s)
{
  var ext = GetExt(s, 4);
  return ( ext == ".GIF" || ext == ".JPG" || ext == ".PNG" );
}

function IsHtml(s)
{
  return GetExt(s, 5).search(/\.HTM/) != -1;
}

function IsFlash(s)
{
  return GetExt(s, 4) == ".SWF";
}

// move in contens ------------------------------------

function PagePrev()
{
  if ( curNr > 0 )
    SetTopic(curNr-1);
}

function PageUp()
{
  if ( curNr == -1 || Deep[curNr] == 0 )
  {
    SetTopic(0);
    return;
  }
  for (var i=curNr; i >= 0; i--)
    if ( Deep[i] < Deep[curNr] )
    {
      SetTopic(i);
      break;
    }
}

function PageNext()
{
  if ( curNr < nTopic-1 )
    SetTopic(curNr+1);
}

function MoveMedia(d)
{
  MedListPos += d;
  StartMedia(Mode % M_MEDIAOPEN, MedList[MedListPos][0], MedList[MedListPos][1]);
}

function Prev()
{
  if ( posHistory > 0 )
    if ( !CheckHistory(posHistory) )
      SetHistory(--posHistory);
}

function Next()
{
  if ( posHistory +1 < nHistory )
    SetHistory(++posHistory);
}

function BackToStuff(oldMode)
{
  if ( curNr != LastChosenTopic )
    UpDateCont(LastChosenTopic);
  if ( ExclTopic(curNr) )
    SetTopicText(curNr);
  else
    ChangeMode(oldMode);
}

// service function ----------------------------------------------------------

function HTML2Text(s)
{
  if ( !s )
    return "";
  var res = "";
  while ( true )
  {
    var i = s.search(/</);
    if  ( i == -1 )
    {
      res += s;
      break;
    }
    res += s.slice(0, i);
    s = s.slice(i+1, s.length);
    i = s.search(/>/);
    if  ( i == -1 )
      break;
    s = s.slice(i+1, s.length);
  }
  res = res.replace(/&auml;/, "");
  res = res.replace(/&ouml;/, "");
  res = res.replace(/&uuml;/, "");
  res = res.replace(/&Auml;/, "");
  res = res.replace(/&Ouml;/, "");
  res = res.replace(/&Ouml;/, "");
  res = res.replace(/&szlig;/, "");
  return res;
}

function TN(s) // two numbers
{
  if ( s < 10 )
    return "0" + s;
  else
    return s;
}

function InsertBR(s)
{
  return s.replace(/\n/g, "<BR>");
}

function CivilizeBlanks(s)
{
  while ( s.length > 0 && s.charAt(0) == " " )
    s = s.slice(1, s.length);
  var i = 1;
  while ( i < s.length )
  {
    if ( s.charAt(i) == " " )
      if ( s.charAt(i-1) == " " )
      {
        var s1 = s;
        s = s1.slice(0, i-1) + s1.slice(i, s1.length);
        continue;
      }
    i++;
  }
  while ( s.length > 0 && s.charAt(s.length-1) == ' ' )
    s = s.slice(0, s.length-1);
  return s;
}

function HTML2StatusText(s)
{
  var res = HTML2Text(s);
  res = res.replace(/'/g, "&rsquo;").replace(/&nbsp;/g, " ");
  return CivilizeBlanks(res);
}

function MouseTip(text, zusatz)
{
  var s1 = HTML2StatusText(text);
  return (s1 != '' ? 'title="' + s1 + '" ' : '') + 'onMouseOver="status=\'' + s1.replace(/'/g, "\\'") + '\';' +
         (zusatz ? zusatz : '') +
         ' return true;" onMouseOut="status=\'\'; return true;"';
}

function GetPath(s, abscheck)
{
  s = ""+s;
  var l = s.length;
  while ( s.charAt(l-1) != '/' && s.charAt(l-1) != '\\' && l > 0 )
    s = s.substr(0, --l);
  if ( abscheck )
    s = s.replace(/\/\\\\/, "\\\\");
  return s;
}

// Materialbank --------------------------------------------------------------

function Material()
{
  Mode = M_MATERIAL;
  ShowMaterial();
  ShowButtons();
}

function MatAdd(type)
{
  var Delete = 0;
  for (var i = 0; i < nMat; i++)
  {
    if  ( Delete )
      Mat[i-1] = Mat[i];
    else
      if ( Mat[i] == type )
        Delete = 1;
  }
  if ( Delete )
    nMat--;
  else
  {
    Mat[nMat] = type;
    nMat++;
  }
  ShowMaterial();
}

// notes ----------------------------------------------------

function InsertNewNote(note)
{
  var i;
  for (i = nNotes-1; i >= -1; i--)
  {
    if ( (i == -1) || (1*Notes[i][0] < 1*note[0]) || ( (1*Notes[i][0] == 1*note[0]) && (1*Notes[i][1] < 1*note[1]) ) )
    {
      Notes[i+1] = note;
      break;
    }
    else
      Notes[i+1] = Notes[i];
  }
  nNotes++;
  return i+1;
}

function TextNote()
{
  TakeOff("Notiz", "#FFA000");
  NoteNr = -1;
  top.data.display.defaultStatus = "Klicken sie auf ein Wort, an das die Notiz geklebt werden soll."
  PlaneMode = PM_NOTE;
}

// Markieren ------------------------------------------------------------

function InsertNewMark(mark)
{
  for (var i = nMarks-1; i >= -1; i--)
    if ( i == -1 || (1*Marks[i][0] <= 1*mark[0]) )
    {
      Marks[i+1] = mark;
      break;
    }
    else
      Marks[i+1] = Marks[i];
  nMarks++;
  S2sSend("mark", mark.join(" "));
}

// aufgabe ---------------------------------------------------------------------------------

function HintWindow(title, text)
{
  NewDia(title,
    '<span class="hintTitle">' + title + ':</span><p>' +
    text +
    '</p><p align=right>\r\n' +
    '<input type="button" value="Schlieen" onClick="self.close()"></p>',
    " ",
    420, 250);
}

function EFSolvedOutfit(nr)
{
  var fm = top.data.display.document.fm;
  if ( fm.EndButton )
    fm.EndButton.value = "Beenden";
  if ( top.data.display.CrashDown && Flight != 0 )
    top.data.display.CrashDown();
}

function EFStartOutfit()
{
  var fm = top.data.display.document.fm;
  if ( navigator.userAgent.search(/MSIE 5\.(\d*); Mac/) != -1 ) // MacIEs mit Hacke
    if ( RegExp.$1*1 > 0 )
    {
      var inp = top.data.display.document.all.tags("input");
      for (var i = 0; i < inp.length; i++)
        if ( inp[i].type == "button" )
          inp[i].style.width="";
    }
  if ( fm.ConfirmButton.length )
    for (var i = 0; i < fm.ConfirmButton.length; i++)
      fm.ConfirmButton[i].value = "Eingabe besttigen";
  else
    fm.ConfirmButton.value = "Eingabe besttigen";
  if ( fm.HintButton )
    if ( fm.HintButton.length )
      for (var i = 0; i < fm.HintButton.length; i++)
        fm.HintButton[i].value = "Hinweis";
    else if ( fm.HintButton )
      fm.HintButton.value = "Hinweis";
  if ( fm.SolveButton )
    if ( fm.SolveButton.length )
      for (var i = 0; i < fm.SolveButton.length; i++)
        fm.SolveButton[i].value = "Lsung";
    else
      fm.SolveButton.value = "Lsung";
  if ( fm.NextButton )
    fm.NextButton.value = "Weiter";
  if ( fm.EndButton )
    fm.EndButton.value = "Abbrechen";
  if ( fm.JumpOverButton )
    fm.JumpOverButton.value = "berspringen";
  if ( fm.DontKnowButton )
    fm.DontKnowButton.value = "Wei nicht";
  if ( top.data.display.iFHint )
    for (var i = 0; i < top.data.display.FHint.length; i++)
      top.data.display.iFHint[i] = 0;
  if ( fm.mailanswerdo )
  {
    fm.appname.value = AppName;
    fm.mailanswerdo.checked = mailanswerdo;
    fm.mailansweraddress.value = mailansweraddress;
  }
//  if ( MedTopic == LastExTopic && MedI == LastExI )
  if ( Mode % M_MEDIAOPEN == M_AUFGABE )
  {
    if ( Media[M_AUFGABE][MedTopic][MedI][9] ) // special
    {
      if ( Media[M_AUFGABE][MedTopic][MedI][9][2] == "STEP" )
        Restore(top.data.display, Media[M_AUFGABE][MedTopic][MedI][7], Media[M_AUFGABE][MedTopic][MedI][8]);
    }
    else
      if ( Media[M_AUFGABE][MedTopic][MedI][7] )
        Restore(top.data.display, Media[M_AUFGABE][MedTopic][MedI][7], Media[M_AUFGABE][MedTopic][MedI][8]);
  }
  if ( top.data.display.ActivateButtons )
    top.data.display.ActivateButtons();
}

function EFHTML2Text(s)
{
  var res = "";
  s = s + "";
  while ( true )
  {
    var i = s.search(/</);
    if  ( i == -1 )
    {
      res += s;
      break;
    }
    res += s.slice(0, i);
    s = s.slice(i+1, s.length);
    i = s.search(/>/);
    if  ( i == -1 )
      break;
    s = s.slice(i+1, s.length);
  }
  res = res.replace(/&auml;/g, "");
  res = res.replace(/&ouml;/g, "");
  res = res.replace(/&uuml;/g, "");
  res = res.replace(/&Auml;/g, "");
  res = res.replace(/&Ouml;/g, "");
  res = res.replace(/&Uuml;/g, "");
  res = res.replace(/&szlig;/g, "");
  return res;
}

function AddHist(s) // Abwrtskompatibilitaet fr Aufgabenschablonen
{
  if ( LastAction == "" ) // Mehrfach lsen
  {
    LastAction = "" + LastMed + "." + MedTopic + "." + MedI;
  }
  AddProt(s);
}

function Partial() // Teilaufgabe gelst
{
}

// save and load ----------------------------------------------------------------------

function MakeString()
{
  var res = "";
  // notes
  for (var i = 0; i < nNotes; i++)
  {
    if ( i != 0 )
      res += "$";
    res += Notes[i][0] + "$" + Notes[i][1] + "$" + Notes[i][2];
  }
  // marks
  res += "|";
  for (var i = 0; i < nMarks; i++)
  {
    if ( i != 0 )
      res += "$";
    res += Marks[i][0] + "$" + Marks[i][1] + "$" + Marks[i][2] + "$" + Marks[i][3];
  }
  // protocol
  res += "|";
  for (var i = 0; i < nProtocol; i++)
  {
    if ( i != 0 )
      res += "$";
    res += Protocol[i];
  }
  // sheets
  res += "|";
  for (var i = 0; i < nSheets; i++)
  {
    if ( i != 0 )
      res += "$";
    res += Sheets[i][1];
    for (var j = 0; j < Sheets[i][0]; j++)
      res += "&" + Sheets[i][j+2];
  }
  // plan
  res += "|";
  if ( UsePlan )
  {
    for (var i = 0; i < Plan.length; i++)
    {
      if ( i != 0 )
        res += "$";
      res += Plan[i][1];
      for (var j = 0; j < Plan[i][0]; j++)
        res += "&" + Plan[i][j+2];
    }
  }
  // exercise content
  res += "|";
  if ( M_AUFGABE != -1 )
  {
    CheckStoreExercise();
    var first = 1;
    for (var j = 0; j < nTopic; j++)
      if ( Media[M_AUFGABE][j] )
        for (var k = 0; k < Media[M_AUFGABE][j].length; k++)
        {
          res += (first == 1 ? "" : "$")+(Media[M_AUFGABE][j][k][7] ? Media[M_AUFGABE][j][k][7].replace(/\$/g, "%24").replace(/\|/g, "%7C") : "");
          first = 0;
          if ( Media[M_AUFGABE][j][k][10] )
            res += "%08"+DataToString(Media[M_AUFGABE][j][k][10]).replace(/\$/g, "%24").replace(/\|/g, "%7C");
          else if ( Media[M_AUFGABE][j][k][9] )
            res += "%08"+DataToString(Media[M_AUFGABE][j][k][9]).replace(/\$/g, "%24").replace(/\|/g, "%7C");
        }
  }
  // SpecialTopics
  res += "|";
  if ( self.SpecialTopic )
  {
    var first = 1;
    for (var j = 0; j < nTopic; j++)
      if ( SpecialTopic[j] )
      {
        res += (first == 1 ? "" : "$")+SpecialTopic[j][0];
        first = 0;
      }
  }
  return res;
}

function ParseString(s)
{
  var Data = s.split("|");
  // notes
  nNotes = 0;
  var Data1 = Data[0].split("$");
  for (var i = 0; i < Data1.length-2; i += 3)
  {
    Notes[nNotes] = new Array(Data1[i], Data1[i+1], Data1[i+2]);
    nNotes++;
  }
  // marks
  nMarks = 0;
  Data1 = Data[1].split("$");
  for (var i = 0; i < Data1.length-3; i += 4)
  {
    Marks[nMarks] = new Array(Data1[i], Data1[i+1], Data1[i+2], Data1[i+3]);
    nMarks++;
  }
  // protocol
  nProtocol = 0;
  if ( Data[2] != "" )
  {
    Data1 = Data[2].split("$");
    for (var i = 0; i < Data1.length; i++)
    {
      Protocol[nProtocol++] = Data1[i];
    }
  }
  // sheets
  nSheets = 0;
  Data1 = Data[3].split("$");
  for (var i = 0; i < Data1.length; i++)
  {
    Sheets[i] = new Array();
    nSheets++;
    var Data2 = Data1[i].split("&");
    Sheets[i][0] = 0;
    Sheets[i][1] = Data2[0];
    for (var j = 1; 2*j < Data2.length; j++)
    {
      Sheets[i][j+1] = '' + Data2[2*j-1] + '&' + Data2[2*j];
      Sheets[i][0]++;
    }
  }
  // plan
  if ( UsePlan && Data.length > 4 && Data[4] != "")
  {
    Data1 = Data[4].split("$");
    for (var i = 0; i < Data1.length; i++)
    {
      var Data2 = Data1[i].split("&");
      Plan[i] = new Array(0, Data2[0]);
      for (var j = 1; 3*j < Data2.length; j++)
      {
        Plan[i][j+1] = '' + Data2[3*j-2] + '&' + Data2[3*j-1] + '&' + Data2[3*j];
        Plan[i][0]++;
      }
    }
  }
  // exercices content
  if ( M_AUFGABE != -1 && Data.length > 5 && Data[5] != "" )
  {
    Data1 = Data[5].split("$");
    var i = 0;
    for (var j = 0; j < nTopic; j++)
      if ( Media[M_AUFGABE][j] )
        for (var k = 0; k < Media[M_AUFGABE][j].length; k++)
        {
          var a = Data1[i++].replace(/%24/g, "$").replace(/%7C/g, "|").split("%08");
          Media[M_AUFGABE][j][k][7] = a[0];
          if ( a.length > 1 )
            Media[M_AUFGABE][j][k][9] = StringToData(a[1]);
        }
  }
  if ( self.SpecialTopic && Data.length > 6 && Data[6] != "" )
  {
    Data1 = Data[6].split("$");
    var i = 0;
    for (var j = 0; j < nTopic; j++)
      if ( SpecialTopic[j] )
        SpecialTopic[j][0] = Data1[i++];
    InitSpec();
  }
  ShowDisplay();
  ShowCont();
}

// Protocol ---------------------------------------------------------

var LastMed = -1;

function InitProt(med, topic, nr)
{
  AddHistory(med, topic, nr, "");
  if ( LastAction != "" )
    AddProt("");
  if ( M_TEXT < med && med < M_TOCMEDIA )
    return;
  LastMed = med % M_MEDIAOPEN;
  LastAction = "" + LastMed + "." + topic + "." + nr;
  var Now = new Date();
  LastTime =  Math.floor(Now.getTime() / 1000);
}

function AddProt(s)
{
  if ( LastAction == "" )
    return;
  var Now = new Date();
  var NowTime =  Math.floor(Now.getTime() / 1000);
  if ( NowTime - LastTime > 10 || s != "" ) // page was watched more than 10 seconds
  {
    LastAction += "&" + LastTime + "&" + (NowTime - LastTime) + "&" + s;
    Protocol[nProtocol++] = LastAction;
    if ( LastMed == M_AUFGABE && s != "" ) //ASP
    {
      LastAction += ' '+AddEFText();
      S2sSendExercise();
      S2sSend("ex", LastAction);
    }
    else
      S2sSend("prot", LastAction);
  }
  LastAction = "";
  if ( LastMed == M_AUFGABE )
  {
    ShowCont();
    ShowButtons();
    var Now = new Date();
    LastTime =  Math.floor(Now.getTime() / 1000); // fr Mehrfachlsen
  }
}

function Dauer(t)
{
  if ( t < 60 )
    return "" + t + " sec";
  if ( t < 3600 )
    return "" + Math.floor(t/60) + '.' + TN(t % 60) + " min";
  return "" + Math.floor(t/3600) + '.' + TN(Math.floor((t % 3600) / 60)) + " h";
}

function ShowProtocol()
{
  AddHistory(M_PROTOCOL, curNr, 0, "");
  S2sSend("prot", "#prot select");
  while ( !top.data.display );
  var doc = top.data.display.document;
  doc.close();
  doc.clear();
  doc.open();
  doc.writeln(DISPLAY_HEADER_BODY,
    '<p>&nbsp;</p>',
    '<p align=center>',
    'Welches Protokoll wollen Sie anschauen?',
    '</p>',
    '<table align=center><tr><td align=center>',
    '<a href="javascript:top.control.setTimeout(\'ShowProtocolList()\', 10)" class="protLink">Ablaufprotokoll<br><br><img src="' + base + '../Data/prot1.gif" border=1></a>',
    '</td><td>',
    '&nbsp; &nbsp; &nbsp;',
    '</td><td align=center>',
    '<a href="javascript:top.control.setTimeout(\'ShowProtocolExercise()\', 10)" class="protLink">Aufgabenprotokoll<br><br><img src="' + base + '../Data/prot2.gif" border=1></a>',
    '</td></tr></table></body></html>');
  doc.close();
}

function ShowProtocolList()
{
  AddHistory(M_PROTOCOL, curNr, 1, "");
  S2sSend("prot", "#prot history");
  while ( !top.data.display );
  var doc = top.data.display.document;
  doc.close();
  doc.clear();
  doc.open();
  doc.writeln(DISPLAY_HEADER_BODY,
    '<table border="1" cellspacing="1" cellpadding="4">\r\n',
    '<tr>\r\n',
    '<td class="protHeader">Datum</td>\r\n',
    '<td class="protHeader">Zeit</td>\r\n',
    '<td class="protHeader">Dauer</td>\r\n',
    '<td class="protHeader">Medium</td>\r\n',
    '<td class="protHeader">Thema</td>\r\n',
    '<td class="protHeader">Titel</td>\r\n',
    '</tr>\r\n');
  for (var i = 0; i < nProtocol; i++)
  {
    var Task = Protocol[i].split("&");
    var What = Task[0].split(".");
    var When = new Date();
    When.setTime(Task[1]*1000);
    doc.writeln('<tr>\r\n',
      '<td>', TN(When.getDate()), '.',  TN(When.getMonth()+1), '.',  TN(When.getYear() % 100), '</td>',
      '<td>', When.getHours(), ':',  TN(When.getMinutes()), '</td>',
      '<td align="right"> ', Dauer(Task[2]), ' </td>',
      '<td>', GetMediaTitleShort(What[0]), '</td>',
      '<td>');
    if ( What[1] == -1 )
      doc.writeln('&nbsp;</td>');
    else
      doc.writeln('<a href="javascript:top.control.SetTopic(' + What[1] + ')" '
      +MouseTip(Name[What[1]], 'top.control.UpDateCont('+What[1]+');')+'>',
        Name[What[1]], '</a>',
        UsePlan ? GetPlanCheckbox(What[0], What[1], What[2]) : '',
        '</td>');
    if ( What[0] == M_TEXT )
      doc.writeln('<td> Lehrtext</td>');
    else if ( What[0] == M_AUFGABE )
    {
      var addText = (Task.length > 3) ? Task[3] : ""
      if ( addText == "" )
        addText = Media[What[0]][What[1]][What[2]][4] != 0 ? "; Bearbeitung abgebrochen" : "";
      else if ( addText == "-1" )
        addText = "Lsung wurde anzeigt";
      else
        addText = "Ergebnis: " + addText + "%";
      doc.writeln('<td>', MediaLink(What[0], What[1], What[2]), '<span class="addText">(', addText, ')</span></td>');
    }
    else
      doc.writeln('<td>', MediaLink(What[0], What[1], What[2]), '</td>');
    doc.writeln('</tr>');
  }
  doc.writeln('</table></body></html>');
  doc.close();
}

function UpdateProt()
{
  // calculate duration
  for (var i = LastTopicRead; i < nProtocol; i++)
  {
    if ( Protocol[i] == "" )
      continue;
    var Task = Protocol[i].split("&");
    var What = Task[0].split(".");
    What[0] *= 1;
    What[1] *= 1;
    if ( What[0] == M_TEXT )
    {
      TopicDuration[What[1]] += 1*Task[2];
      TopicLast[What[1]] = Task[1];
    }
    else if ( IsMediaMode(What[0]) )
    {
      GetMedia(What[0], What[1])[What[2]][4] += 1*Task[2];
      GetMedia(What[0], What[1])[What[2]][5] = Task[1];
      if ( What[0] == M_AUFGABE )
        if ( Task[3] && Task[3] != "" )
        {
	  var Task3 = Task[3].replace(/ .*/, '');
          if ( Task3 == -1 )
            Task3 = 0;
          if ( GetMedia(What[0], What[1])[What[2]][6] < Task3 )
            GetMedia(What[0], What[1])[What[2]][6] = 1*Task3;
          Protocol[i] = Protocol[i].replace(/ .*/, '');
        }
    }
  }
  LastTopicRead = nProtocol;
}

function GetAddText(sCode, not)
{
  var res = "";
  for (var i = nProtocol-1; i >= 0; i--)
    if ( sCode == Protocol[i].substring(0, sCode.length) )
    {
      var Task = Protocol[i].split("&");
      if ( !not || Task[3] != not )
        return Task[3];
      else
        res = not;
    }
  return res;
}

function GetExerciseResult(name)
{
  if ( M_AUFGABE == -1 )
    return 0;
  var addText = "";
  for (var i = 0; i < Name.length; i++)
    if ( Media[M_AUFGABE][i] )
      for (var j=0; j < Media[M_AUFGABE][i].length; j++)
        if ( Media[M_AUFGABE][i][j][1] == name )
          addText = GetAddText("" + M_AUFGABE+ "." + i + "." + j, "-1");
  return addText;
}

// ProtocolExercise -------------------------------------------------

function ProtPillar(doc, vals, l)
{
  var first = 1;
  var sumAll = 0;
  for (var i = 0; i < vals.length; i++)
    sumAll += vals[i];
  var cName = new Array("gruen", "gelb", "rot", "blau");
  var cComment = new Array("richtig gelst", "teilweise richtig gelst", "falsch gelst", "unbearbeitet");
  var pix = 0;
  var sum = 0;
  doc.writeln('<table border="0" cellspacing="0" width="50"><tr><td align="left" valign="top" width="40">');
  for (var i = vals.length-1; i >= 0; i--)
    if ( vals[i] != 0)
    {
      sum += vals[i];
      var sumPix = Math.floor(sum*l/sumAll+0.5);
      doc.write((first == 1 ) ? "" : "<br>",
        '<img src="' + base + '../Data/pc_', cName[i] ,'.gif" width="40" height="', sumPix-pix, '" '+(ie||lay?'alt':'title')+'="', vals[i],
        (vals[i] == 1) ? ' Aufgabe ' : ' Aufgaben ', cComment[i], '">');
      first = 0;
      pix = sumPix;
    }
  doc.writeln('</td></tr></table>');
}

function ShowProtocolExercise()
{
  AddHistory(M_PROTOCOL, curNr, 2, "");
  S2sSend("prot", "#prot exercises");
  while ( !top.data.display );
  var doc = top.data.display.document;
  doc.close();
  doc.clear();
  doc.open();
  doc.writeln(DISPLAY_HEADER_BODY);
  if ( M_AUFGABE == -1 )
  {
    doc.writeln('Keine Aufgaben eingebunden.</body></html>');
    return;
  }
  doc.writeln('<table border="0"><tr><td><table border="0" cellpadding="5" width="100%"><tr>');
  var l = 200;
  // Skale
  doc.writeln('<td align="right" valign="bottom" style="white-space:nowrap">',
    '<img src="' + base + '../Data/ps_100.gif" height="11" width="30"><img src="' + base + '../Data/ps_t.gif" height="11" width="5"><br>',
    '<img src="' + base + '../Data/ps_line.gif" width="5" height="',l/4-11 ,'"><br>',
    '<img src="' + base + '../Data/ps_75.gif" height="11" width="26"><img src="' + base + '../Data/ps_m.gif" height="11" width="5"><br>',
    '<img src="' + base + '../Data/ps_line.gif" width="5" height="',l/4-11 ,'"><br>',
    '<img src="' + base + '../Data/ps_50.gif" height="11" width="26"><img src="' + base + '../Data/ps_m.gif" height="11" width="5"><br>',
    '<img src="' + base + '../Data/ps_line.gif" width="5" height="',l/4-11 ,'"><br>',
    '<img src="' + base + '../Data/ps_25.gif" height="11" width="26"><img src="' + base + '../Data/ps_m.gif" height="11" width="5"><br>',
    '<img src="' + base + '../Data/ps_line.gif" width="5" height="',l/4-11 ,'"><br>',
    '<img src="' + base + '../Data/ps_b.gif" width="5" height="6">',
    '</td>');
  var BlockVals = new Array();
  BlockVals[0] = new Array(0, 0, 0, 0);
  var BlockNr = new Array();
  var j = 0; // Anzahl der Balken
  // beste Aufteilung finden
  var SplitDeep = 0;
  var nSplit = 0;
  for (var i = 0; i < nTopic; i++)
    if ( Deep[i] == 0 )
      nSplit++;
  if ( nSplit == 1 )
    SplitDeep++;
  for (var i = 0; i < nTopic; i++)
  {
    if ( Deep[i] == SplitDeep )
    {
      if ( BlockVals[j][0] + BlockVals[j][1] + BlockVals[j][2] + BlockVals[j][3] > 0 )
      {
        j++;
        BlockVals[j] = new Array(0, 0, 0, 0);
      }
      BlockNr[j] = i;
    }
    if ( Media[M_AUFGABE][i] )
      for (var k = 0; k < Media[M_AUFGABE][i].length; k++)
        if ( Media[M_AUFGABE][i][k][6] == -1 )
          BlockVals[j][3]++;
        else if ( Media[M_AUFGABE][i][k][6] >= 98 )
          BlockVals[j][0]++;
        else if ( Media[M_AUFGABE][i][k][6] >= 1 )
          BlockVals[j][1]++;
        else
          BlockVals[j][2]++;
  }
  if ( BlockVals[j][0] + BlockVals[j][1] + BlockVals[j][2] + BlockVals[j][3] > 0 )
    j++;
  var SummVals = new Array(0, 0, 0, 0);
  // Blcke drucken
  for (var i = 0; i < j; i++)
  {
    doc.writeln('<td width="'+100/(j+1)+'%" valign="bottom">');
    ProtPillar(doc, BlockVals[i], l);
    doc.writeln('</td>');
    SummVals[0] += BlockVals[i][0];
    SummVals[1] += BlockVals[i][1];
    SummVals[2] += BlockVals[i][2];
    SummVals[3] += BlockVals[i][3];
  }
  doc.writeln('<td width="'+100/(j+1)+'%" valign="bottom">');
  ProtPillar(doc, SummVals, l);
  // Skale
  doc.writeln('</td>',
    '<td align="left" valign="bottom" style="white-space:nowrap">',
    '<img src="' + base + '../Data/ps_t.gif" height="11" width="5"><img src="' + base + '../Data/ps_100.gif" height="11" width="30"><br>',
    '<img src="' + base + '../Data/ps_line.gif" width="5" height="',l/4-11 ,'"><br>',
    '<img src="' + base + '../Data/ps_m.gif" height="11" width="5"><img src="' + base + '../Data/ps_75.gif" height="11" width="26"><br>',
    '<img src="' + base + '../Data/ps_line.gif" width="5" height="',l/4-11 ,'"><br>',
    '<img src="' + base + '../Data/ps_m.gif" height="11" width="5"><img src="' + base + '../Data/ps_50.gif" height="11" width="26"><br>',
    '<img src="' + base + '../Data/ps_line.gif" width="5" height="',l/4-11 ,'"><br>',
    '<img src="' + base + '../Data/ps_m.gif" height="11" width="5"><img src="' + base + '../Data/ps_25.gif" height="11" width="26"><br>',
    '<img src="' + base + '../Data/ps_line.gif" width="5" height="',l/4-11 ,'"><br>',
    '<img src="' + base + '../Data/ps_b.gif" width="5" height="6">',
    '</td>',
    '</tr><tr><td>&nbsp;</td>');
  for (var i = 0; i < j; i++)
    doc.writeln('<td width="'+(100/(j+1))+'%" valign="top" bgcolor="#FFFF80',
      '" class="protBlock">' + Name[BlockNr[i]] + '</td>');
  doc.writeln('<td valign="top" bgcolor="#FFFF80"><font face="Arial"><strong>gesamt</strong></font></td><td>&nbsp;</td></tr></table></td></tr></table>\r\n',
    '&nbsp;\r\n',
    '<table border="0" cellpadding="3"><tr>\r\n',
    '<td><img src="' + base + '../Data/pc_gruen.gif" width="20" height="20"></td>\r\n',
    '<td>Richtig gel&ouml;ste Aufgaben.</td>\r\n',
    '</tr><tr>\r\n',
    '<td><img src="' + base + '../Data/pc_gelb.gif" width="20" height="20"></td>\r\n',
    '<td>Teilweise richtig gel&ouml;ste Aufgaben.</td>\r\n',
    '</tr><tr>\r\n',
    '<td><img src="' + base + '../Data/pc_rot.gif" width="20" height="20"></td>\r\n',
    '<td>Falsch gel&ouml;ste Aufgaben.</td>\r\n',
    '</tr><tr>\r\n',
    '<td><img src="' + base + '../Data/pc_blau.gif" width="20" height="20"></td>\r\n',
    '<td>Noch nicht bearbeitete Aufgaben.</td>\r\n',
    '</tr></table></body></html>');
  doc.close();
}

// Sheets --------------------------------------------------------------------------

function CheckSheet()
{
  if ( curSheets == -1 )
  {
    if ( nSheets == 0)
    {
      Sheets[nSheets++] = new Array();
      Sheets[0][0] = 0;
      Sheets[0][1] = "unbenannt";
    }
    curSheets = 0;
  }
}

function EditSheetEntry(nr)
{
  var Task = Sheets[curSheets][nr].split("&");
  var What = Task[0].split(".");
  var TheTitle = Name[What[1]];
  if ( What[0] < M_TEXT )
    TheTitle = GetMedia(What[0], What[1])[What[2]][1];
  NewDia(
    'Sammelmappeneintrag lschen/verschieben',
    '<B>' + TheTitle + '</B> (' + GetMediaTitleShort(What[0]) + ')<P>' +
    '<table><tr><td>Den Eintrag</td><td>' +
    '<input type="button" value="Lschen" onClick="ReturnWin.EraseSheetEntry(' + nr +')"></td></tr>\r\n' +
    '<tr><td colspan=2><HR></td></tr>' +
    '<tr><td>Den Eintrag an die <input type=text name="Nr" size=3>. Stelle&nbsp;'+
    '</td><td><input type="button" value="Verschieben" onClick="ReturnWin.MoveSheetEntry(' +
    nr +', Nr.value-1)"></td></tr>\r\n' +
    '</table>\r\n' +
    '<HR><P align="right"><input type="button" value="Abbruch" onClick="self.close()"></P>',
    ' ',
    400, 300, 200, 200, -1);
}

function EraseSheetEntry(nr)
{
  for (var i = nr; i < Sheets[curSheets][0]+1; i++)
    Sheets[curSheets][i] = Sheets[curSheets][i+1];
  Sheets[curSheets][0]--;
  DiaWin.close();
  ShowSheet();
  S2sSend("sheet", "ERASE "+curSheets+" "+nr);
}

function MoveSheetEntry(nr, toNr)
{
  toNr += 2;
  var s = Sheets[curSheets][nr];
  var i;
  if ( nr < toNr )
  {
    for (i = nr; i < Sheets[curSheets][0]+1 && i < toNr; i++)
      Sheets[curSheets][i] = Sheets[curSheets][i+1];
    Sheets[curSheets][i] = s;
  }
  else if ( toNr < nr )
  {
    for (i = nr; i > toNr; i--)
      Sheets[curSheets][i] = Sheets[curSheets][i-1];
    Sheets[curSheets][i] = s;
  }
  DiaWin.close();
  ShowSheet();
  S2sSend("sheet", "MOVE "+curSheets+" "+nr+" "+toNr);
}

function SheetSelection()
{
  var res = '<select name="Sheet">\r\n';
  for (var i = 0; i < nSheets; i++)
    res += '<option' + ((i == curSheets) ? " selected" : "") + '> ' + (Sheets[i][1].split("\x01")[0]) + '<BR>\r\n';
  res += ' </select>\r\n';
  return res;
}

function AddSheet(medium, topic, nr)
{
  CheckSheet();
  var TheTitle = Name[topic];
  if ( medium < M_TEXT )
    TheTitle = Media[medium][topic][nr][1];
  NewDia(
    'Zu Sammelmappe hinzufgen',
    '<B>' + TheTitle + '</B> (' + GetMediaTitleShort(medium) + ')<P>' +
    'in Sammelmappe ' +
    SheetSelection() +
    '<P>\r\n' +
    'Kommentar<BR>\r\n<textarea name="Comment" cols="45" rows="5"></textarea>\r\n' +
    '<P align="right"><input type="button" value="Hinzufgen" onClick="Add()">\r\n' +
    '<input type="button" value="Abbruch" onClick="self.close()"></P>',
    'function Add()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.AddSheetOk(' + medium + ',' + topic + ',' + nr +
    ', fm.Sheet.selectedIndex, fm.Comment.value);\r\n' +
    '  self.close();\r\n' +
    '}\r\n',
    420, 300, 200, 200, 1);
}

function AddSheetOk(medium, topic, nr, sheet, comment)
{
  Sheets[sheet][2+(Sheets[sheet][0]++)] = "" + medium + '.' + topic + '.' + nr + '&' + comment;
  S2sSend("sheet", "ADD "+sheet+" "+medium+" "+topic+" "+nr+" "+comment);
}

function CommentSheet(nr)
{
  var Task = Sheets[curSheets][nr+2].split("&");
  var What = Task[0].split(".");
  var TheTitle = Name[What[1]];
  if ( What[0] < M_TEXT )
    TheTitle = GetMedia(What[0], What[1])[What[2]][1];
  NewDia(
    'Kommentar bearbeiten',
    '<B>' + TheTitle + '</B> (' + GetMediaTitleShort(What[0]) + ')<P>' +
    'Kommentar<BR>\r\n<textarea name="Comment" cols="45" rows="5">' +
    Task[1] +
    '</textarea>\r\n' +
    '<P align="right"><input type="button" value="  Ok  " onClick="Edit()">\r\n' +
    '<input type="button" value="Abbruch" onClick="self.close()"></P>',
    'function Edit()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.CommentSheetOk(' + curSheets + ',' + nr + ', fm.Comment.value);\r\n' +
    '  self.close();\r\n' +
    '}\r\n',
    420, 270, 200, 200, 0);
}

function CommentSheetOk(sheet, nr, comment)
{
  var Task = Sheets[sheet][nr+2].split("&");
  Sheets[sheet][nr+2] = Task[0] + '&' + comment;
  if ( Mode == M_INTEGRATOR )
    ShowSheet();
  S2sSend("sheet", "COMMENT "+sheet+" "+nr+" "+comment);
}

function RenameSheet()
{
  var sheetData = Sheets[curSheets][1].split("\x01");
  NewDia(
    'Sammelmappe umbenennen',
    'Neuer Name<BR>' +
    '<input type=text name="NewName" size=45 maxlength=45 value="' +
    sheetData[0] +
    '">' +
    '<BR>Bemerkung<BR>' +
    '<textarea name="NewComment" cols=45 rows=5>' +
    (sheetData.length > 1 ? sheetData[1] : '')+
    '</textarea>' +
    '<P align="right"><input type="button" value="  Ok  " onClick="Rename()">\r\n' +
    '<input type="button" value="Abbruch" onClick="self.close()"></P>',
    'function Rename()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.RenameSheetOk(' + curSheets + ', fm.NewName.value, fm.NewComment.value);\r\n' +
    '  self.close();\r\n' +
    '}\r\n',
    480, 230, 200, 200, 0);
}

function RenameSheetOk(sheet, name, comment)
{
  Sheets[sheet][1] = name + (comment != '' ? '\x01'+comment : '');
  if ( Mode == M_INTEGRATOR )
    ShowSheet();
  S2sSend("sheet", "RENAME "+sheet+" "+name);
}

var DiaClosed = 1;

function SelectSheet()
{
  NewDia(
    'Sammelmappe auswhlen',
    'Sammelmappe<BR>' +
    SheetSelection() +
    '<P align="right"><input type="button" value="  Ok  " onClick="SelectIt()">\r\n' +
    '<input type="button" value=" Neu " onClick="New()">\r\n' +
    '<input type="button" value="Abbruch" onClick="self.close()"></P>',
    'function SelectIt()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.SelectSheetOk(fm.Sheet.selectedIndex);\r\n' +
    '  self.close();\r\n' +
    '}\r\n' +
   'function New()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.setTimeout("NewSheet()", 200);\r\n' +
    '  self.close();\r\n' +
    '}\r\n',
     420, 160, 200, 200, 0);
  DiaClosed = 0;
}

function SelectSheetOk(sheet)
{
  curSheets = sheet;
  if ( Mode == M_INTEGRATOR )
    ShowSheet();
}


function NewSheet()
{
  if ( DiaWin && !DiaWin.closed )
  {
    if ( DiaClosed == 0 )
    {
      DiaClosed = 1;
      DiaWin.close();
    }
    setTimeout('NewSheet()', 200);
  }
  NewDia(
    'Neue Sammelmappe',
    'Name der neuen Sammelmappe<BR>' +
    '<input type=text name="NewName" size=45 maxlength=45 value="">' +
    '<BR>Bemerkung<BR>' +
    '<textarea name="NewComment" cols=45 rows=5></textarea>' +
    '<P align="right"><input type="button" value="  Ok  " onClick="New()">\r\n' +
    '<input type="button" value="Abbruch" onClick="self.close()"></P>',
    'function New()\r\n' +
    '{\r\n' +
    '  while ( typeof ReturnWin != "object" );\r\n' +
    '  ReturnWin.NewSheetOk(fm.NewName.value, fm.NewComment.value);\r\n' +
    '  self.close();\r\n' +
    '}\r\n',
    480, 230, 200, 200, 0);
}

function NewSheetOk(name, comment)
{
  Sheets[nSheets] = new Array();
  Sheets[nSheets][0] = 0;
  Sheets[nSheets][1] = name + (comment != '' ? '\x01'+comment : '');
  curSheets = nSheets++;
  if ( Mode == M_INTEGRATOR )
    ShowSheet();
  S2sSend("sheet", "NEW "+curSheets+" "+name);
}

function KillSheet()
{
  if ( confirm('Soll die Sammelmappe "' + (Sheets[curSheets][1].split("\x01")[0]) +'" wirklich gelscht werden?') )
  {
    var s2s_help = curSheets; // s2send
    for (var i = curSheets; i < nSheets-1; i++)
      Sheets[i] = Sheets[i+1];
    nSheets--;
    curSheets = -1;
    CheckSheet();
    ShowSheet();
    S2sSend("sheet", "KILL "+s2s_help);
  }
}

function PlayPrevSheet()
{
  if ( PlayNr > 0 )
    PlayNrSheet(--PlayNr);
}

function PlayNextSheet()
{
  if ( PlayNr < Sheets[curSheets][0] )
    PlayNrSheet(++PlayNr);
}

function StopSheet()
{
  ContMode += 2;
  Mode = M_INTEGRATOR;
  SwitchContMode();
  ShowButtons();
}

// Links from text --------------------------------------------------

function VisitMedia(topic, media, i, anc)
{
  if ( Mode == M_TEXT )
    BackAction = "curNr = " + (1*curNr) +"; ChangeMode(" + M_TEXT +");ShowTitle();ShowCont();";
  else if ( Mode == M_OVERVIEW + M_MEDIAOPEN )
    BackAction = 'StartMedia(' + M_OVERVIEW + ', ' + curNr + ', ' + MedI + ');ShowTitle();ShowCont();';
  else
    BackAction = 'curNr = ' + (1*curNr) + '; StartMedia(' + Mode + ', ' + curNr + ', ' + MedI + ');ShowCont();';
  // evtl. Strings auflsen
  if ( isNaN(Number(topic)) ) {
    var l1 = topic.length;
    for (var i1 = 0; i1 < nTopic; i1++)
      if ( topic == Name[i1].substr(0, l1) ) {
        topic = i1;
        break;
      }
    if ( isNaN(Number(topic)) )
      topic = 0;
  }
  if ( isNaN(Number(media)) ) {
    var l1 = media.length;
    for (var i1 = 0; i1 < MediaTitle.length; i1++)
      if ( media == MediaTitle[i1].substr(0, l1) ) {
        media = i1;
        break;
      }
    if ( isNaN(Number(media)) )
      for (var i1 = 0; i1 < InTOCMediaTitle.length; i1++)
        if ( media == InTOCMediaTitle[i1].substr(0, l1) ) {
          media = i1+M_TOCMEDIA;
          break;
        }
    if ( isNaN(Number(media)) )
      for (var i1 = 0; i1 < MediaTitle.length; i1++)
        if ( media == MediaTitleShort[i1].substr(0, l1) ) {
          media = i1;
          break;
      }
    if ( isNaN(Number(media)) )
      for (var i1 = 0; i1 < InTOCMediaTitle.length; i1++)
        if ( media == InTOCMediaTitleShort[i1].substr(0, l1) ) {
          media = i1+M_TOCMEDIA;
          break;
        }
    if ( isNaN(Number(media)) )
      media = -1;
  }
  if ( isNaN(Number(i)) ) {
    var l1 = i.length;
    var mData = GetMedia(media, topic);
    for (var i1 = 0; i1 < mData.length; i1++)
      if ( i == mData[i1][0].substr(0, l1) || i == mData[i1][1].substr(0, l1) ) {
        i = i1;
        break;
      }
    if ( isNaN(Number(i)) )
      i = 0;
  }
  if ( media == -1 ) // nur Text
  {
    Mode = M_TEXT;
    SetTopic(topic);
    return;
  }
  else if ( i == -1 )
  {
    curNr = topic;
    ChangeMode(media);
  }
  else
  {
    StartMedia(media, topic, i, anc);
    return;
  }
  setTimeout("ShowTitle()", 30);
  setTimeout("ShowCont()", 40);
}

// StartMedia

function MediaPage(type, winName, text)
{
  var doc = (GetMediaStyle(type) & 2) ? self.open("", winName).document : top.data.display.document;
  doc.close();
  doc.clear();
  doc.open();
  doc.writeln(HEADER, DISPLAY_HEADER, text, '</body>');
  doc.close();
}

var LinkCount = 0;

function StartMedia(type, nr, i, anc)
{
  CheckStoreExercise();
  MedMode = type;
  MedTopic = nr;
  MedI = i;
  if ( self.SpecialTopic && SpecialTopic[nr] &&
    (SpecialTopic[nr][0] & 4) && SpecialTopic[nr][1] == type+"."+i ) // Gate
    UnBlock(nr);
  if ( curNr != nr && M_TEXT <= Mode && Mode < M_TOCMEDIA )
  {
    MedListMode = -1;
    curNr = nr;
    ShowCont();
  }
  Mode = 1*type+M_MEDIAOPEN;
  AddProt("");
  if ( !(GetMediaStyle(type) & 2) )
  {
    ShowButtons();
    ShowTitle();
  }
  var Med = GetMedia(type, nr)[i];
  var src = Med[0];
  if ( src.substr(0,2) == "##" )
  {
    var Task = src.substr(2).split("#");
    VisitMedia(1*Task[0], 1*Task[1], 1*Task[2], Task.length > 3 ? Task.slice(3, Task.length).join("#") : "");
    return;
  }
  InitProt(Mode, nr, i);
  if ( src == "" )
  {
    StartEmptyMedia(type, nr, i);
    return;
  }
  if ( (k = src.search(/"(\s*)split(\s*)=(\s*)"(.*)$/i)) != -1 )
  {
    splitNew = RegExp.$4;
    src = src.substring(0, k);
    // kommt spter;
  }
  if ( Med[0].search(/:/) == -1 )
    src = base + Med[0];
  if ( anc )
    src += anc;
  var winName = escape(GetMediaTitle(type)).replace(/\%/g, "_").replace(/-/g, "_");
  if ( StartMediaNative(src, type, winName, Med) )
    return;
  if ( IsFlash(src) )
    MediaPage(type, winName,
      '<embed src="' + src + '" quality=high pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash" type="application/x-shockwave-flash"></embed>'+
      '<P><FONT size=4 color=#0000FF>' +
      Med[1] + '</FONT><BR>' + Med[2] + '</P>');
  else if ( (Mode == M_VIDEO+M_MEDIAOPEN || Mode == M_VIDEO) && !IsHtml(src) )
    MediaPage(type, winName,
      '<embed src="' + src + '" autostart=true></embed><P><FONT size=4 color=#0000FF>' +
      Med[1] + '</FONT><BR>' + Med[2] + '</P>');
  else if ( (Mode == M_EXPERIMENT+M_MEDIAOPEN || Mode == M_EXPERIMENT) && !IsHtml(src) )
    MediaPage(type, winName,
      '<A href="' + src + '" autostart=true>Zum START hier klicken</A><P><FONT size=4 color=#0000FF>' +
      Med[1] + '</FONT><BR>' + Med[2] + '</P>');
  else if ( Mode == M_LINK+M_MEDIAOPEN || Mode == M_LINK )
    window.open(src, "link"+(LinkCount++));
  else if ( (Mode == M_AUFGABE+M_MEDIAOPEN || Mode == M_AUFGABE) && Med[9] )
  {
    if ( GetMediaStyle(type) & 2 )
      window.open(Med[9][0], Med[9][1]);
    else
    {
      var v = top.data.display;
      v.name = Med[9][1];
      v.open(Med[9][0], Med[9][1]);
    }
  }
  else
    StartStandardMedia(src, type, winName, Med);
}

function StartEmptyMedia(mode, nr, i)
{
  var doc = top.data.display.document;
  doc.close();
  doc.clear();
  doc.open();
  doc.writeln(HEADER, DISPLAY_HEADER,
    '<FONT face="Arial"><FONT size="4" color="#CC0000"><B>',
    GetMediaTitle(mode),
    '</B></FONT><P><B>',
    MediaLink(mode, nr, i), '</B><P>',
    GetMedia(mode, nr)[i][2],
    '<P align="right"><FONT size="2">(Kein Link zugewiesen.)</FONT>');
  doc.close();
}

function StartStandardMedia(src, type, winName, med)
{
  if ( src.indexOf('"') != -1 )  // medium mit parametern
    MediaPage(type, winName,
      (IsGraphic(src) ? '<img src="'+src+'"' :
      '<embed src="'+src+'"'+(src.toUpperCase().indexOf('AUTOSTART') != -1 ? '' : ' autostart=true'))+
      '><P><FONT size=4 color=#0000FF>' +
      med[1]+ '</FONT><BR>'+ med[2]+ '</P>');
  else
    window.open(src, GetMediaStyle(type) & 2 ? winName : "display");
}

// Init -------------------------------

var MatBG = new Array();
var CapTopic = new Array();
var aLastTopic = new Array();

var M_QUEST = -1;
var Quest = new Array();

var para = new Array(); // Startparameter

function Init()
{
  if ( (!ie && !dom) || (""+navigator.userAgent).indexOf("Safari") != -1 )
    tableButtons = true;
  ButtonSep = tableButtons ? '<td>&nbsp;</td>' : '&nbsp; ';

  // background graphics
  for (var i = 0; i < MediaTitle.length; i++)
  {
    var s = MediaTitleShort[i];
    s = s.replace(/\./g, "");
    s = s.replace(//g, "ae");
    s = s.replace(//g, "Ae");
    s = s.replace(//g, "oe");
    s = s.replace(//g, "Oe");
    s = s.replace(//g, "ue");
    s = s.replace(//g, "Ue");
    s = s.replace(//g, "sz");
    for (var j = 0; j < s.length; j++)
      if ( s.charCodeAt(j) > 127 )
        s = s.substr(0, j)+"_"+s.substr(j+1);
    MatBG[i] = s;
    if ( s.toUpperCase() == "QUEST" )
      M_QUEST = i
  }

  var LastCap = new Array();
  for (var i = 0; i < nTopic; i++)
  {
    TopicDuration[i] = 0;
    IsOpen[i] = 0;
    LastCap[Deep[i]] = i;
    CapTopic[i] = ( Deep[i] == 0 ) ? -1 : LastCap[Deep[i]-1];
    aLastTopic[i] = 0;
  }

  for (var i = nTopic-1; i >= 0; i--)
    if ( CapTopic[i] != -1 )
      if ( aLastTopic[CapTopic[i]] == 1 )
        aLastTopic[i] = 0;
      else
      {
        aLastTopic[i] = 1;
        aLastTopic[CapTopic[i]] = 1
      }

  for (var i = 0; i < MediaTitle.length; i++)
    for (var j = 0; j < nTopic; j++)
      if ( Media[i][j] )
        for (var k = 0; k < Media[i][j].length; k++)
        {
    Media[i][j][k][2] = PadExpand(Media[i][j][k][2]);
    Media[i][j][k][4] = 0;
          Media[i][j][k][5] = 0;
          Media[i][j][k][6] = -1;
        }

  // Quest-Zeug
  if ( M_QUEST != -1 )
  {
    // Scan Quests
    for (var j = 0; j < nTopic; j++)
      if ( Media[M_QUEST][j] )
        Quest[Quest.length] = new Array(0, Media[M_QUEST][j][0][1], M_AUFGABE, j);
    // Quest aus Mat entfernen
    for (var i = 0; i < Mat.length; i++)
      if ( Mat[i] == M_QUEST )
      {
        var arr = (Mat.slice(0, i-1)).concat(Mat.slice(0, i+1));
        Mat = arr;
        nMat--;
        break;
      }
  }

  // StartParameter lesen
  var s = top.location.href;
  var p1 = s.indexOf("?");
  if ( p1 != -1 ) {
    var arr = s.substr(p1+1).split("&");
    for (var j = 0; j < arr.length; j++)
      if ( (k = arr[j].indexOf("=")) != -1 )
        para[arr[j].substr(0, k).toLowerCase()] = arr[j].substr(k+1);
      else
        para[arr[j].toLowerCase()] = "true";
  }

  if ( para["topic"] ) {
    var l1 = para["topic"].length;
    for (var i = 0; i < nTopic; i++)
      if ( para["topic"] == Name[i].substr(0, l1) ) {
        curNr = i;
        break;
      }
  }

  if ( self.SpecialTopic )
    InitSpec();

  SwitchContMode();

  if ( para["load"] )
    setTimeout("S2sLoadData(para)", 100);
  else
    if ( !bas )
      DoLoadData();

  // LernplanGrafiken
  if ( UsePlan ) {
    PlanImg[0].src = base+"../Data/planboxb0.gif";
    PlanImg[1].src = base+"../Data/planboxb1.gif";
  }
}

function GetTopicHaken(nr)
{
  if ( M_AUFGABE == -1 )
    return false;
  var val = false;
  for (var i = nr; i < nTopic; i++)
    if ( i != nr && Deep[nr] == Deep[i] )
      break;
    else
      if ( Media[M_AUFGABE][i] )
        for (var j = 0; j < Media[M_AUFGABE][i].length; j++)
          if ( Media[M_AUFGABE][i][j][6] == -1 )
            return false;
          else
            val = true;
  return val;
}

// Lernpfad

function SLP(mode, nr, i)
{
  if ( top.control.SLPText )
  {
    if ( mode == M_TEXT )
      return SLPText[nr];
    else if ( SLPMedia[mode] && SLPMedia[mode][nr] && SLPMedia[mode][nr][i] )
      return SLPMedia[mode][nr][i];
  }
  return 0;
}

function SLP_L(mode, nr, i)
{
  return (SLP(mode, nr, i) == 1) ? "l" : "";
}

// Topic bzw. transdown hat Medien (nicht auf Cat's weitergesplittet)
function TopicAndCapsHasMedia(mode, nr)
{
  if ( GetMedia(mode, nr) )
    return true;
  // mit TRANSDOWNS versuchen
  var nr1 = CapTopic[nr];
  while ( nr1 != -1 )
  {
    var med = GetMedia(mode, nr1);
    if ( med )
      for (var i = 0; i < med.length; i++)
         if ( med[i][3] & 1 != 0 )
           return true;
    nr1 = CapTopic[nr1];
  }
  return false;
}

// Topic bzw. transdown hat Medien (nicht auf Cat's weitergesplittet)
function TopicAndCapsHasGraphicMedia(mode, nr)
{
  var nr1 = nr;
  while ( nr1 != -1 )
  {
    var med = GetMedia(mode, nr1);
    if ( med )
      for (var i = 0; i < med.length; i++)
         if ( nr1 == nr || med[i][3] & 1 != 0 )
           if ( IsGraphic(med[i][0]) )
             return true;
    nr1 = CapTopic[nr1];
  }
  return false;
}

// Aktuelle Medienliste generieren, (rekursiv, da von allgemein zu speziell)

function MakeMedList(mode, nr)
{
  MedListMode = mode;
  MedListTopic = nr;
  MedList = new Array();
  MakeMedListRek(nr, nr);
  MedListPos = -1;
}

function MakeMedListRek(nr1, nr)
{
  if ( CapTopic[nr1] != -1 )
    MakeMedListRek(CapTopic[nr1], nr);
  var med = GetMedia(MedListMode, nr1);
  if ( med )
    for (var i = 0; i < med.length; i++)
      if ( nr1 == nr || med[i][3] & 1 != 0 )
        MedList[MedList.length] = new Array(nr1, i);
}

// Achtung! nr ist Nr des (transdowned) Mediums, kann von curNr abweichen
function CheckUpdateMedListPos(mode, nr, i)
{
  if ( MedListMode != mode )
    MakeMedList(mode, curNr);
  MedListPos = 0;
  for (var j = 0; j < MedList.length; j++)
    if ( MedList[j][0] == nr && MedList[j][1] == i )
    {
      MedListPos = j;
      break;
    }
}

function CheckUpdateMedList(mode, nr, i)
{
  if ( MedListMode != mode || MedListTopic != curNr )
    MakeMedList(mode, curNr);
  CheckUpdateMedListPos(mode, nr, i);
}

// History ----------------------------------------------------------

var History = new Array();
var nHistory = 0;
var posHistory = -1;

function AddHistory(mode, nr, i, add)
{
  var s = ""+mode+"."+nr+"."+i+"."+add;
  if ( posHistory < 0 || History[posHistory] != s )
  {
    History[++posHistory] = ""+mode+"."+nr+"."+i+"."+add;
    nHistory = posHistory+1;
  }
}

function SetHistory(pos)
{
  var w = History[pos].split(".");
  Mode = 1*w[0];
  curNr = 1*w[1];
  if ( IsMediaMode(1*w[0]) && w[0] >= M_MEDIAOPEN )
  {
    StartMedia(1*w[0] % M_MEDIAOPEN, 1*w[1], 1*w[2]);
/*    if ( w[3] != "" && GetMediaStyle(1*w[0], 1*w[1]) & 8 != 0)
      top.data.display.glossdata.GotoGloss(w[3]);*/
    ShowCont();
  }
  else if ( w[0] == M_PROTOCOL )
  {
    if ( w[2] == 1 )
      ShowProtocolList();
    else if ( w[2] == 2 )
      ShowProtocolExercise();
    else
      ShowProtocol();
  }
  else
  {
    ShowDisplay();
    ShowButtons();
    ShowTitle();
    ShowCont();
  }
}

function CheckHistory(pos) // falls via Link auf Seite den study-Bereich verlassen
{
  var w = History[pos].split(".");
  var Mode1 = Number(w[0]);
  var curNr1 = Number(w[1]);
  if ( Mode1 == M_TEXT )
    if ( (""+top.data.display.location).indexOf(File[curNr1]) == -1 )
    {
      SetHistory(pos);
      return true;
    }
  return false;
}

// kepp exercise-Entries

var LastExTopic = -1;
var LastExI = -1;

function CheckStoreExercise()
{
  if ( Mode != M_AUFGABE+M_MEDIAOPEN )
    return;
  if ( top.data.display.Store )
  {
    Media[M_AUFGABE][MedTopic][MedI][9] = top.data.display.Store(M_AUFGABE, MedTopic, MedI);
    Media[M_AUFGABE][MedTopic][MedI][7] = StoreHard(top.data.display);
    Media[M_AUFGABE][MedTopic][MedI][8] = StoreSoft(top.data.display);
  }
  else
  {
    Media[M_AUFGABE][MedTopic][MedI][7] = StoreHard(top.data.display);
    Media[M_AUFGABE][MedTopic][MedI][8] = StoreSoft(top.data.display);
  }
  LastExTopic = MedTopic;
  LastExI = MedI;
}

// Hilfe

function Help()
{
  var xl = 910, yl = 550;
  if ( xl+50 > screen.availWidth )
    xl = screen.availWidth-50;
  if ( yl+80 > screen.availWidth )
    yl = screen.availWidth-80;
  window.open(base+'../S2_Help/user_doc.htm', 'help', "dependent=yes,location=no,menubar=no,status=no,resizable=yes,left=40,top=70,width="+xl+",height="+yl);
}

// GlossaryLink

function GlossaryLink(topic, media, i, word)
{
  VisitMedia(topic, media, i, '#'+word);
}

// Soundlink

function PlaySound(snd)
{
  if ( document.EFPlayer1 )
    document.EFPlayer1.fileName = base+snd;
  else if ( document.EFPlayer2 )
    document.EFPlayer2.SetFileName((op ? base.replace(/^file:\/\/localhost\//, ''): base)+snd);
  else alert('Player not properly installed.');
}

// SpecialTopics

var AvailField;

function InitSpec()
{
  AvailField = new Array();
  for (var i = 0; i < nTopic; i++)
    AvailField[i] = true;
  for (var i = 0; i < nTopic; i++)
  {
    if ( SpecialTopic[i] )
    {
      if ( SpecialTopic[i][0] & 12 )
        for (var j = i+1; j < SpecialTopic[i][2]; j++)
          AvailField[j] = false;
      if ( SpecialTopic[i][0] & 16 )
        AvailField[i] = false;
    }
  }
  if ( !Available(curNr) ) // falls Startpara
    curNr = 0;
}

function Available(nr)
{
  return nr == -1 || !AvailField || AvailField[nr] == true;
}

function UnBlock(nr)
{
  if ( !nr )
    nr = curNr;
  if ( !top.control.SpecialTopic || (!SpecialTopic[nr] && !(SpecialTopic[nr][0] & 12)) )
    return false;
  SpecialTopic[nr][0] &= 3;
  InitSpec();
  ShowCont();
}

function UnBlockToLock(nr)
{
  if ( !nr )
    nr = curNr;
  if ( !SpecialTopic[nr] && !(SpecialTopic[nr][0] & 12) )
    return false;
  SpecialTopic[nr][0] &= 3;
  SpecialTopic[nr][0] |= 16;
  InitSpec();
  SetTopic(nr+1);
}

function ExclTopic(nr)
{
  return self.SpecialTopic && SpecialTopic[nr] && (SpecialTopic[nr][0] & 2);
}

function MaterialTopic(nr)
{
  if ( Available(nr) )
    return '      <A href="javascript:top.control.SetTopicText(' + nr + ')" '+
      MouseTip(Name[nr], 'top.control.UpDateCont('+nr+');')+'><B>'+Name[nr]+'</B></A>\r\n';
  else
    return '      <font color=#666666><B>'+Name[nr]+'</B></font>\r\n';
}


function SaveLoadINTOC(nr)
{
  NewDia("Persnliche Daten",
    '<P>Persnlich Daten verwalten:</P>'+
    '<P><input type=button value="Daten laden" onclick="ReturnWin.LoadData();self.close()"> '+
    '<input type=button value="Daten speichern" onclick="ReturnWin.SaveData(true);self.close()"></P> '+
    '<P align=right><input type=button value="Abbrechen" onclick="self.close()"></P>',
    " ",
    280, 190, 100, 100, 0);
}

function PadExpand(s)
{
  var s1 = s.replace(/\\\\/g, "\\");
  var i;
  while ( (i = s1.indexOf("[[@m::")) != -1 )
  {
    var j = s1.indexOf("]]", i);
    if ( j == -1 )
      return s1;
    s1 = s1.substr(0, i)+(self.MPadJava ? Text2Javam : Text2m)(s1.substring(i+6, j), j)+s1.substr(j+2);
  }
  return s1;
}

function FinalizePage()
{
  if ( self.MPadJava )
  {
    MPadJavaData = new Array();
    setTimeout("CheckRedimMPadJava("+curNr+")", 100);
  }
}

// Daten auf Server sichern -------------------------------------------------------------

var isS2s = '';
var ExtQuest = new Array();
var StartTime = (new Date()).getTime()/1000;

function S2sLoadData(para)
{
  isS2s = para['load'];
  if ( top.send && top.send.document &&  top.send.document.forms && top.send.document.forms[0] && top.send.document.forms[0].user )
  {
    var f = top.send.document.forms[0];
    f.appName.value = AppName;
    f.action = para['load'];
    f.course.value = para['course'];
    f.stupla.value = para['stupla'];
    f.user.value = para['user'];
    f.browser.value = "["+navigator.userAgent+(navigator.platform ? "]["+navigator.platform : "")+"]";
    f.submit();
  }
  else
    setTimeout("S2sLoadData(para)", 500);
}

function S2sLoadBack() // ASP
{
  StartTime = (new Date()).getTime()/1000;
  if ( top.send.NewUser == "kickout" )
  {
     top.location.replace(base+"../Data/kickout.htm");
     return;
  }
  if ( top.send.NewUser == 0 )
  {
    //alert(top.send.document.body.innerHTML);
    Marks = top.send.Marks;
    nMarks = Marks.length;
    Notes = top.send.Notes;
    nNotes = Notes.length;
    Sheets = top.send.Sheets;
    nSheets = Sheets.length;
    if ( UsePlan)
      Plan = top.send.Plan;
    Protocol = top.send.Protocol;
    nProtocol = Protocol.length;
    for (var i = 0; i < top.send.Ex.length; i += 2)
    {
      var w = top.send.Ex[i].split(/\./);
      var m = Media[w[0]][w[1]][w[2]];
      var a = top.send.Ex[i+1].replace(/%24/g, "$").replace(/%7C/g, "|").split("%08");
      m[7] = a[0];
      if ( a.length > 1 )
        m[9] = StringToData(a[1]);
    }
    SetFBStates(top.send.FBLoad);
    if ( top.send.ExtQuest ) {
    	ExtQuest = top.send.ExtQuest;
    }
    top.send.document.bgColor = "#C000C0";
  }
  ShowDisplay();
  ShowCont();
}

// MOODLE --------------------------------------------------------------

function S2sSend(type, data)
{
  if ( isS2s == '' )
    return;
  if ( type == "sheet" )
    S2sSheets2Send();
  if ( type == "plan" )
    S2sPlan2Send();
  var f = top.send.document.forms[0];
//  if ( f.Marks )
//    f.action = f.action.replace(/savefirst/, "prot");
  f.type.value = type;
  f.data.value = data.replace(/\n/g, "\\n").replace(/\r/g, "\\r");
  top.send.document.bgColor = "#C00000";
  f.submit();
}

function S2sSendExercise()
{
  if ( isS2s == '' )
    return;
  var ex = Media[M_AUFGABE][LastExTopic][LastExI];
  var s = ""+M_AUFGABE+"."+LastExTopic+"."+LastExI+" "+(ex[7] ? ex[7].replace(/\$/g, "%24").replace(/\|/g, "%7C") : "");
  if ( ex[10] )
    s += "%08"+DataToString(ex[10]).replace(/\$/g, "%24").replace(/\|/g, "%7C");
  else if ( ex[9] )
    s += "%08"+DataToString(ex[9]).replace(/\$/g, "%24").replace(/\|/g, "%7C");
  top.send.document.forms[0].data2.value = s;
}

function S2sSheets2Send()
{
  var s = "new Array(\r\n  ";
  for (var i = 0; i < nSheets; i++)
  {
    if ( i )
      s += ",\r\n  ";
    s += "new Array("+Sheets[i][0];
    for (var j = 1; j < Sheets[i][0]+2; j++)
      s += ", \"" + (""+Sheets[i][j]).replace(/\"/g, "\\\"") + "\"";
    s += ")";
  }
  s += ")";
  top.send.document.forms[0].data2.value = s;
}

function S2sPlan2Send()
{
  var s = "new Array(\r\n  ";
  for (var i = 0; i < Plan.length; i++)
  {
    if ( i )
      s += ",\r\n  ";
    s += "new Array("+Plan[i][0];
    for (var j = 1; j < Plan[i][0]+2; j++)
      s += ", \"" + (""+Plan[i][j]).replace(/\"/g, "\\\"") + "\"";
    s += ")";
  }
  s += ")";
  top.send.document.forms[0].data2.value = s;
}

function S2sSaveFirstData()
{
  var f = top.send.document.forms[0];
  f.User.value = User;
  f.AppName.value = AppName;
  // marks
  var s = "";
  for (var i = 0; i < nMarks; i++)
    s += Marks[i].join(' ')+"\r\n";
  f.Marks.value = s;
  // notes
  var s = "";
  for (var i = 0; i < nNotes; i++)
    s += Notes[i][0]+' '+Notes[i][1]+Notes[i][2].replace(/\n/g, "\\n").replace(/\r/g, "\\r")+"\r\n";
  f.Notes.value = s;
  // sheets
  S2sSheets2Send();
  // plan
  if ( UsePlan )
    S2sPlan2Send();
  // prot
  var s = "";
  for (var i = 0; i < nProtocol; i++)
    s += "0 "+Protocol[i]+"\r\n";
  f.Prot.value = s;
  f.submit();
}

function S2sFBBack(done)
{
  if ( done == 1 )
    FBTime = 0;
  else
    window.open("../fb/inhalte"+AppName+'.htm#'+User+"#close", "FB"+AppName);
}

function SendableString(s)
{
  var sSendable = s;
  sSendable = sSendable.replace(/ /g, "_");
  sSendable = sSendable.replace(/\t/g, "_");
  sSendable = sSendable.replace(/\n/g, "//");
  sSendable = sSendable.replace(/\r/g, "//");
  return sSendable;
}

function AddEFText()
{
  var ef = top.data.display;
  CheckStoreExercise();
  var FullFilled = true;
  //sEF = ef.m.join(";");
  var sEF = "";
  for (var i = 0; i < ef.m.length; i++)
  {
    if ( i != 0 )
      sEF += '|';
    if ( ef.Type[i] <= 1 )
      sEF += '[mc]'+(ef.m[i]+1);
    else
      sEF += ef.m[i];
  }
  sEF = SendableString(sEF);
  return sEF;
}

function S2sSendSyst(nr, i, deep, s)
{
  S2sSend("prot", "#systerror "+LastMed + "." + MedTopic + "." + MedI+" "+nr+" "+i+" "+deep+" "+SendableString(s));
}

function SetFBStates(s)
{
  for (var i = 0; i < Quest.length; i++)
    Quest[i][0] = s.indexOf(Quest[i][1]) != -1 ? 1 : 0;
}

var fbType, fbNr, fbI;

function CheckFB(type, nr, i)
{
  fbType = type;
  fbNr = nr;
  fbI = i;
  for (var i = 0; i < Quest.length; i++)
    if ( Quest[i][0] == 0 )
      if ( type == Quest[i][2] && nr >= Quest[i][3] )
      {
        window.open("../../asp/s2_fbrequest.asp?Nr="+Quest[i][1]+"&User="+User+"&AppName="+AppName, 'display');
        return false;
      }
  return true;
}

function FBBack(fbs)
{
  SetFBStates(fbs);
  if ( CheckFB(fbType, fbNr, fbI) )
    StartMedia(fbType, fbNr, fbI);
}

var curExtQuest = -1;

function CheckFBs() {
	var t = (new Date()).getTime()/1000-StartTime;
	for (var i = 0; i < ExtQuest.length; i++) {
		if ( 0 <= ExtQuest[i][2] && ExtQuest[i][2] < t ) {
			window.open(ExtQuest[i][1], "display");
			AddProt("");
		  S2sSend("prot", "#fbrequest "+ExtQuest[i][0]);
			curExtQuest = i;
			return true;
		}
	}
	return false;	
}

function ReturnFB(values) {
	if ( curExtQuest >= 0 ) {
		S2sSend("quest", ExtQuest[curExtQuest][0]+" "+Math.floor((new Date()).getTime()/1000)+" "+values)
		ExtQuest[curExtQuest][2] = -1;
		curExtQuest = -1;
		SetTopic(LastChosenTopic);
	}
}

